/**
 * Mars2D平台插件,ArcGIS Server功能支持插件  mars2d-esri
 *
 * 版本信息：v3.3.1
 * 编译日期：2025-02-06 14:18
 * 版权所有：Copyright by 火星科技  http://mars2d.cn
 * 使用单位：免费公开版 ，2024-01-16
 */
(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, (window.L || require('leaflet')), (window.mars2d || require('mars2d'))) :
  typeof define === 'function' && define.amd ? define(['exports', 'leaflet', 'mars2d'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["mars2d-esri"] = {}, global.L, global.mars2d));
})(this, (function (exports, L, mars2d) { 'use strict';

  function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return n;
  }

  var L__default = /*#__PURE__*/_interopDefaultLegacy(L);
  var mars2d__namespace = /*#__PURE__*/_interopNamespace(mars2d);

  var name = "esri-leaflet";
  var description = "Leaflet plugins for consuming ArcGIS Online and ArcGIS Server services.";
  var version$1 = "3.0.12";
  var author = "Patrick Arlt <parlt@esri.com> (http://patrickarlt.com)";
  var bugs = {
  	url: "https://github.com/esri/esri-leaflet/issues"
  };
  var contributors = [
  	"Patrick Arlt <parlt@esri.com> (http://patrickarlt.com)",
  	"John Gravois (https://johngravois.com)",
  	"Gavin Rehkemper <grehkemper@esri.com> (https://gavinr.com)",
  	"Jacob Wasilkowski (https://jwasilgeo.github.io)"
  ];
  var dependencies = {
  	"@terraformer/arcgis": "^2.1.0",
  	"tiny-binary-search": "^1.0.3"
  };
  var devDependencies = {
  	"@rollup/plugin-json": "^6.0.0",
  	"@rollup/plugin-node-resolve": "^15.0.1",
  	"@rollup/plugin-terser": "^0.3.0",
  	chai: "4.3.7",
  	"chokidar-cli": "^3.0.0",
  	"gh-release": "^7.0.1",
  	"highlight.js": "^11.7.0",
  	"http-server": "^14.1.1",
  	husky: "^1.1.1",
  	karma: "^6.4.1",
  	"karma-chrome-launcher": "^3.1.1",
  	"karma-coverage": "^2.2.0",
  	"karma-edgium-launcher": "github:matracey/karma-edgium-launcher",
  	"karma-firefox-launcher": "^2.1.2",
  	"karma-mocha": "^2.0.1",
  	"karma-mocha-reporter": "^2.2.5",
  	"karma-safari-launcher": "~1.0.0",
  	"karma-sinon-chai": "^2.0.2",
  	"karma-sourcemap-loader": "^0.3.8",
  	leaflet: "^1.6.0",
  	mkdirp: "^1.0.4",
  	mocha: "^10.2.0",
  	"npm-run-all": "^4.1.5",
  	rollup: "^2.79.1",
  	semistandard: "^14.2.3",
  	sinon: "^15.0.1",
  	"sinon-chai": "3.7.0",
  	snazzy: "^9.0.0"
  };
  var files = [
  	"src/**/*.js",
  	"dist/esri-leaflet.js",
  	"dist/esri-leaflet.js.map",
  	"dist/esri-leaflet-debug.js.map",
  	"dist/siteData.json",
  	"profiles/*.js"
  ];
  var homepage = "https://developers.arcgis.com/esri-leaflet/";
  var module = "src/EsriLeaflet.js";
  var jspm = {
  	registry: "npm",
  	format: "es6",
  	main: "src/EsriLeaflet.js"
  };
  var keywords = [
  	"arcgis",
  	"esri",
  	"esri leaflet",
  	"gis",
  	"leaflet plugin",
  	"mapping"
  ];
  var license = "Apache-2.0";
  var main = "dist/esri-leaflet-debug.js";
  var peerDependencies = {
  	leaflet: "^1.0.0"
  };
  var readmeFilename = "README.md";
  var repository = {
  	type: "git",
  	url: "git@github.com:Esri/esri-leaflet.git"
  };
  var scripts = {
  	build: "rollup -c profiles/debug.js & rollup -c profiles/production.js",
  	lint: "semistandard | snazzy",
  	prebuild: "mkdirp dist",
  	pretest: "npm run build",
  	fix: "semistandard --fix",
  	release: "./scripts/release.sh",
  	"start-watch": "chokidar src -c \"npm run build\"",
  	start: "run-p start-watch serve",
  	serve: "http-server -p 5000 -c-1 -o",
  	test: "npm run lint && karma start"
  };
  var semistandard = {
  	globals: [
  		"expect",
  		"L",
  		"XMLHttpRequest",
  		"sinon",
  		"xhr",
  		"proj4"
  	]
  };
  var unpkg = "dist/esri-leaflet-debug.js";
  var husky = {
  	hooks: {
  		"pre-commit": "npm run lint"
  	}
  };
  var packageInfo = {
  	name: name,
  	description: description,
  	version: version$1,
  	author: author,
  	bugs: bugs,
  	contributors: contributors,
  	dependencies: dependencies,
  	devDependencies: devDependencies,
  	files: files,
  	homepage: homepage,
  	module: module,
  	"jsnext:main": "src/EsriLeaflet.js",
  	jspm: jspm,
  	keywords: keywords,
  	license: license,
  	main: main,
  	peerDependencies: peerDependencies,
  	readmeFilename: readmeFilename,
  	repository: repository,
  	scripts: scripts,
  	semistandard: semistandard,
  	unpkg: unpkg,
  	husky: husky
  };

  var cors = ((window.XMLHttpRequest && 'withCredentials' in new window.XMLHttpRequest()));
  var pointerEvents = document.documentElement.style.pointerEvents === '';

  var Support = {
    cors: cors,
    pointerEvents: pointerEvents
  };

  var options = {
    attributionWidthOffset: 55
  };

  var callbacks = 0;

  function serialize (params) {
    var data = '';

    params.f = params.f || 'json';

    for (var key in params) {
      if (Object.prototype.hasOwnProperty.call(params, key)) {
        var param = params[key];
        var type = Object.prototype.toString.call(param);
        var value;

        if (data.length) {
          data += '&';
        }

        if (type === '[object Array]') {
          value = (Object.prototype.toString.call(param[0]) === '[object Object]') ? JSON.stringify(param) : param.join(',');
        } else if (type === '[object Object]') {
          value = JSON.stringify(param);
        } else if (type === '[object Date]') {
          value = param.valueOf();
        } else {
          value = param;
        }

        data += encodeURIComponent(key) + '=' + encodeURIComponent(value);
      }
    }

    const APOSTROPHE_URL_ENCODE = '%27';
    return data.replaceAll("'", APOSTROPHE_URL_ENCODE);
  }

  function createRequest (callback, context) {
    var httpRequest = new window.XMLHttpRequest();

    httpRequest.onerror = function (e) {
      httpRequest.onreadystatechange = L.Util.falseFn;

      callback.call(context, {
        error: {
          code: 500,
          message: 'XMLHttpRequest error'
        }
      }, null);
    };

    httpRequest.onreadystatechange = function () {
      var response;
      var error;

      if (httpRequest.readyState === 4) {
        try {
          response = JSON.parse(httpRequest.responseText);
        } catch (e) {
          response = null;
          error = {
            code: 500,
            message: 'Could not parse response as JSON. This could also be caused by a CORS or XMLHttpRequest error.'
          };
        }

        if (!error && response.error) {
          error = response.error;
          response = null;
        }

        httpRequest.onerror = L.Util.falseFn;

        callback.call(context, error, response);
      }
    };

    httpRequest.ontimeout = function () {
      this.onerror();
    };

    return httpRequest;
  }

  function xmlHttpPost (url, params, callback, context) {
    var httpRequest = createRequest(callback, context);
    httpRequest.open('POST', url);

    if (typeof context !== 'undefined' && context !== null) {
      if (typeof context.options !== 'undefined') {
        httpRequest.timeout = context.options.timeout;
      }
    }
    httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
    httpRequest.send(serialize(params));

    return httpRequest;
  }

  function xmlHttpGet (url, params, callback, context) {
    var httpRequest = createRequest(callback, context);
    httpRequest.open('GET', url + '?' + serialize(params), true);

    if (typeof context !== 'undefined' && context !== null) {
      if (typeof context.options !== 'undefined') {
        httpRequest.timeout = context.options.timeout;
        if (context.options.withCredentials) {
          httpRequest.withCredentials = true;
        }
      }
    }
    httpRequest.send(null);

    return httpRequest;
  }

  // AJAX handlers for CORS (modern browsers) or JSONP (older browsers)
  function request (url, params, callback, context) {
    var paramString = serialize(params);
    var httpRequest = createRequest(callback, context);
    var requestLength = (url + '?' + paramString).length;

    // ie10/11 require the request be opened before a timeout is applied
    if (requestLength <= 2000 && Support.cors) {
      httpRequest.open('GET', url + '?' + paramString);
    } else if (requestLength > 2000 && Support.cors) {
      httpRequest.open('POST', url);
      httpRequest.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
    }

    if (typeof context !== 'undefined' && context !== null) {
      if (typeof context.options !== 'undefined') {
        httpRequest.timeout = context.options.timeout;
        if (context.options.withCredentials) {
          httpRequest.withCredentials = true;
        }
      }
    }

    // request is less than 2000 characters and the browser supports CORS, make GET request with XMLHttpRequest
    if (requestLength <= 2000 && Support.cors) {
      httpRequest.send(null);

    // request is more than 2000 characters and the browser supports CORS, make POST request with XMLHttpRequest
    } else if (requestLength > 2000 && Support.cors) {
      httpRequest.send(paramString);

    // request is less  than 2000 characters and the browser does not support CORS, make a JSONP request
    } else if (requestLength <= 2000 && !Support.cors) {
      return jsonp(url, params, callback, context);

    // request is longer then 2000 characters and the browser does not support CORS, log a warning
    } else {
      warn('a request to ' + url + ' was longer then 2000 characters and this browser cannot make a cross-domain post request. Please use a proxy https://developers.arcgis.com/esri-leaflet/api-reference/request/');
      return;
    }

    return httpRequest;
  }

  function jsonp (url, params, callback, context) {
    window._EsriLeafletCallbacks = window._EsriLeafletCallbacks || {};
    var callbackId = 'c' + callbacks;
    params.callback = 'window._EsriLeafletCallbacks.' + callbackId;

    window._EsriLeafletCallbacks[callbackId] = function (response) {
      if (window._EsriLeafletCallbacks[callbackId] !== true) {
        var error;
        var responseType = Object.prototype.toString.call(response);

        if (!(responseType === '[object Object]' || responseType === '[object Array]')) {
          error = {
            error: {
              code: 500,
              message: 'Expected array or object as JSONP response'
            }
          };
          response = null;
        }

        if (!error && response.error) {
          error = response;
          response = null;
        }

        callback.call(context, error, response);
        window._EsriLeafletCallbacks[callbackId] = true;
      }
    };

    var script = L.DomUtil.create('script', null, document.body);
    script.type = 'text/javascript';
    script.src = url + '?' + serialize(params);
    script.id = callbackId;
    script.onerror = function (error) {
      if (error && window._EsriLeafletCallbacks[callbackId] !== true) {
        // Can't get true error code: it can be 404, or 401, or 500
        var err = {
          error: {
            code: 500,
            message: 'An unknown error occurred'
          }
        };

        callback.call(context, err);
        window._EsriLeafletCallbacks[callbackId] = true;
      }
    };
    L.DomUtil.addClass(script, 'esri-leaflet-jsonp');

    callbacks++;

    return {
      id: callbackId,
      url: script.src,
      abort: function () {
        window._EsriLeafletCallbacks._callback[callbackId]({
          code: 0,
          message: 'Request aborted.'
        });
      }
    };
  }

  var get = ((Support.cors) ? xmlHttpGet : jsonp);
  get.CORS = xmlHttpGet;
  get.JSONP = jsonp;

  function warn () {
    if (console && console.warn) {
      console.warn.apply(console, arguments);
    }
  }

  // export the Request object to call the different handlers for debugging
  var Request = {
    request: request,
    get: get,
    post: xmlHttpPost
  };

  /* @preserve
  * @terraformer/arcgis - v2.1.1 - MIT
  * Copyright (c) 2012-2022 Environmental Systems Research Institute, Inc.
  * Tue Aug 02 2022 14:23:48 GMT-0700 (Pacific Daylight Time)
  */
  /* Copyright (c) 2012-2019 Environmental Systems Research Institute, Inc.
   * Apache-2.0 */

  var edgeIntersectsEdge = function edgeIntersectsEdge(a1, a2, b1, b2) {
    var uaT = (b2[0] - b1[0]) * (a1[1] - b1[1]) - (b2[1] - b1[1]) * (a1[0] - b1[0]);
    var ubT = (a2[0] - a1[0]) * (a1[1] - b1[1]) - (a2[1] - a1[1]) * (a1[0] - b1[0]);
    var uB = (b2[1] - b1[1]) * (a2[0] - a1[0]) - (b2[0] - b1[0]) * (a2[1] - a1[1]);

    if (uB !== 0) {
      var ua = uaT / uB;
      var ub = ubT / uB;

      if (ua >= 0 && ua <= 1 && ub >= 0 && ub <= 1) {
        return true;
      }
    }

    return false;
  };
  var coordinatesContainPoint = function coordinatesContainPoint(coordinates, point) {
    var contains = false;

    for (var i = -1, l = coordinates.length, j = l - 1; ++i < l; j = i) {
      if ((coordinates[i][1] <= point[1] && point[1] < coordinates[j][1] || coordinates[j][1] <= point[1] && point[1] < coordinates[i][1]) && point[0] < (coordinates[j][0] - coordinates[i][0]) * (point[1] - coordinates[i][1]) / (coordinates[j][1] - coordinates[i][1]) + coordinates[i][0]) {
        contains = !contains;
      }
    }

    return contains;
  };
  var pointsEqual = function pointsEqual(a, b) {
    for (var i = 0; i < a.length; i++) {
      if (a[i] !== b[i]) {
        return false;
      }
    }

    return true;
  };
  var arrayIntersectsArray = function arrayIntersectsArray(a, b) {
    for (var i = 0; i < a.length - 1; i++) {
      for (var j = 0; j < b.length - 1; j++) {
        if (edgeIntersectsEdge(a[i], a[i + 1], b[j], b[j + 1])) {
          return true;
        }
      }
    }

    return false;
  };

  /* Copyright (c) 2012-2019 Environmental Systems Research Institute, Inc.
   * Apache-2.0 */

  var closeRing = function closeRing(coordinates) {
    if (!pointsEqual(coordinates[0], coordinates[coordinates.length - 1])) {
      coordinates.push(coordinates[0]);
    }

    return coordinates;
  }; // determine if polygon ring coordinates are clockwise. clockwise signifies outer ring, counter-clockwise an inner ring
  // or hole. this logic was found at http://stackoverflow.com/questions/1165647/how-to-determine-if-a-list-of-polygon-
  // points-are-in-clockwise-order

  var ringIsClockwise = function ringIsClockwise(ringToTest) {
    var total = 0;
    var i = 0;
    var rLength = ringToTest.length;
    var pt1 = ringToTest[i];
    var pt2;

    for (i; i < rLength - 1; i++) {
      pt2 = ringToTest[i + 1];
      total += (pt2[0] - pt1[0]) * (pt2[1] + pt1[1]);
      pt1 = pt2;
    }

    return total >= 0;
  }; // This function ensures that rings are oriented in the right directions
  // from http://jsperf.com/cloning-an-object/2

  var shallowClone = function shallowClone(obj) {
    var target = {};

    for (var i in obj) {
      // both arcgis attributes and geojson props are just hardcoded keys
      if (obj.hasOwnProperty(i)) {
        // eslint-disable-line no-prototype-builtins
        target[i] = obj[i];
      }
    }

    return target;
  };

  /* Copyright (c) 2012-2019 Environmental Systems Research Institute, Inc.
   * Apache-2.0 */

  var coordinatesContainCoordinates = function coordinatesContainCoordinates(outer, inner) {
    var intersects = arrayIntersectsArray(outer, inner);
    var contains = coordinatesContainPoint(outer, inner[0]);

    if (!intersects && contains) {
      return true;
    }

    return false;
  }; // do any polygons in this array contain any other polygons in this array?
  // used for checking for holes in arcgis rings


  var convertRingsToGeoJSON = function convertRingsToGeoJSON(rings) {
    var outerRings = [];
    var holes = [];
    var x; // iterator

    var outerRing; // current outer ring being evaluated

    var hole; // current hole being evaluated
    // for each ring

    for (var r = 0; r < rings.length; r++) {
      var ring = closeRing(rings[r].slice(0));

      if (ring.length < 4) {
        continue;
      } // is this ring an outer ring? is it clockwise?


      if (ringIsClockwise(ring)) {
        var polygon = [ring.slice().reverse()]; // wind outer rings counterclockwise for RFC 7946 compliance

        outerRings.push(polygon); // push to outer rings
      } else {
        holes.push(ring.slice().reverse()); // wind inner rings clockwise for RFC 7946 compliance
      }
    }

    var uncontainedHoles = []; // while there are holes left...

    while (holes.length) {
      // pop a hole off out stack
      hole = holes.pop(); // loop over all outer rings and see if they contain our hole.

      var contained = false;

      for (x = outerRings.length - 1; x >= 0; x--) {
        outerRing = outerRings[x][0];

        if (coordinatesContainCoordinates(outerRing, hole)) {
          // the hole is contained push it into our polygon
          outerRings[x].push(hole);
          contained = true;
          break;
        }
      } // ring is not contained in any outer ring
      // sometimes this happens https://github.com/Esri/esri-leaflet/issues/320


      if (!contained) {
        uncontainedHoles.push(hole);
      }
    } // if we couldn't match any holes using contains we can try intersects...


    while (uncontainedHoles.length) {
      // pop a hole off out stack
      hole = uncontainedHoles.pop(); // loop over all outer rings and see if any intersect our hole.

      var intersects = false;

      for (x = outerRings.length - 1; x >= 0; x--) {
        outerRing = outerRings[x][0];

        if (arrayIntersectsArray(outerRing, hole)) {
          // the hole is contained push it into our polygon
          outerRings[x].push(hole);
          intersects = true;
          break;
        }
      }

      if (!intersects) {
        outerRings.push([hole.reverse()]);
      }
    }

    if (outerRings.length === 1) {
      return {
        type: 'Polygon',
        coordinates: outerRings[0]
      };
    } else {
      return {
        type: 'MultiPolygon',
        coordinates: outerRings
      };
    }
  };

  var getId = function getId(attributes, idAttribute) {
    var keys = idAttribute ? [idAttribute, 'OBJECTID', 'FID'] : ['OBJECTID', 'FID'];

    for (var i = 0; i < keys.length; i++) {
      var key = keys[i];

      if (key in attributes && (typeof attributes[key] === 'string' || typeof attributes[key] === 'number')) {
        return attributes[key];
      }
    }

    throw Error('No valid id attribute found');
  };

  var arcgisToGeoJSON$1 = function arcgisToGeoJSON(arcgis, idAttribute) {
    var geojson = {};

    if (arcgis.features) {
      geojson.type = 'FeatureCollection';
      geojson.features = [];

      for (var i = 0; i < arcgis.features.length; i++) {
        geojson.features.push(arcgisToGeoJSON(arcgis.features[i], idAttribute));
      }
    }

    if (typeof arcgis.x === 'number' && typeof arcgis.y === 'number') {
      geojson.type = 'Point';
      geojson.coordinates = [arcgis.x, arcgis.y];

      if (typeof arcgis.z === 'number') {
        geojson.coordinates.push(arcgis.z);
      }
    }

    if (arcgis.points) {
      geojson.type = 'MultiPoint';
      geojson.coordinates = arcgis.points.slice(0);
    }

    if (arcgis.paths) {
      if (arcgis.paths.length === 1) {
        geojson.type = 'LineString';
        geojson.coordinates = arcgis.paths[0].slice(0);
      } else {
        geojson.type = 'MultiLineString';
        geojson.coordinates = arcgis.paths.slice(0);
      }
    }

    if (arcgis.rings) {
      geojson = convertRingsToGeoJSON(arcgis.rings.slice(0));
    }

    if (typeof arcgis.xmin === 'number' && typeof arcgis.ymin === 'number' && typeof arcgis.xmax === 'number' && typeof arcgis.ymax === 'number') {
      geojson.type = 'Polygon';
      geojson.coordinates = [[[arcgis.xmax, arcgis.ymax], [arcgis.xmin, arcgis.ymax], [arcgis.xmin, arcgis.ymin], [arcgis.xmax, arcgis.ymin], [arcgis.xmax, arcgis.ymax]]];
    }

    if (arcgis.geometry || arcgis.attributes) {
      geojson.type = 'Feature';
      geojson.geometry = arcgis.geometry ? arcgisToGeoJSON(arcgis.geometry) : null;
      geojson.properties = arcgis.attributes ? shallowClone(arcgis.attributes) : null;

      if (arcgis.attributes) {
        try {
          geojson.id = getId(arcgis.attributes, idAttribute);
        } catch (err) {// don't set an id
        }
      }
    } // if no valid geometry was encountered


    if (JSON.stringify(geojson.geometry) === JSON.stringify({})) {
      geojson.geometry = null;
    }

    if (arcgis.spatialReference && arcgis.spatialReference.wkid && arcgis.spatialReference.wkid !== 4326) {
      console.warn('Object converted in non-standard crs - ' + JSON.stringify(arcgis.spatialReference));
    }

    return geojson;
  };

  /* Copyright (c) 2012-2019 Environmental Systems Research Institute, Inc.
   * Apache-2.0 */
  // outer rings are clockwise, holes are counterclockwise
  // used for converting GeoJSON Polygons to ArcGIS Polygons

  var orientRings = function orientRings(poly) {
    var output = [];
    var polygon = poly.slice(0);
    var outerRing = closeRing(polygon.shift().slice(0));

    if (outerRing.length >= 4) {
      if (!ringIsClockwise(outerRing)) {
        outerRing.reverse();
      }

      output.push(outerRing);

      for (var i = 0; i < polygon.length; i++) {
        var hole = closeRing(polygon[i].slice(0));

        if (hole.length >= 4) {
          if (ringIsClockwise(hole)) {
            hole.reverse();
          }

          output.push(hole);
        }
      }
    }

    return output;
  }; // This function flattens holes in multipolygons to one array of polygons
  // used for converting GeoJSON Polygons to ArcGIS Polygons


  var flattenMultiPolygonRings = function flattenMultiPolygonRings(rings) {
    var output = [];

    for (var i = 0; i < rings.length; i++) {
      var polygon = orientRings(rings[i]);

      for (var x = polygon.length - 1; x >= 0; x--) {
        var ring = polygon[x].slice(0);
        output.push(ring);
      }
    }

    return output;
  };

  var geojsonToArcGIS$1 = function geojsonToArcGIS(geojson, idAttribute) {
    idAttribute = idAttribute || 'OBJECTID';
    var spatialReference = {
      wkid: 4326
    };
    var result = {};
    var i;

    switch (geojson.type) {
      case 'Point':
        result.x = geojson.coordinates[0];
        result.y = geojson.coordinates[1];

        if (geojson.coordinates[2] != null) {
          result.z = geojson.coordinates[2];
        }

        result.spatialReference = spatialReference;
        break;

      case 'MultiPoint':
        result.points = geojson.coordinates.slice(0);

        if (geojson.coordinates[0][2] != null) {
          result.hasZ = true;
        }

        result.spatialReference = spatialReference;
        break;

      case 'LineString':
        result.paths = [geojson.coordinates.slice(0)];

        if (geojson.coordinates[0][2] != null) {
          result.hasZ = true;
        }

        result.spatialReference = spatialReference;
        break;

      case 'MultiLineString':
        result.paths = geojson.coordinates.slice(0);

        if (geojson.coordinates[0][0][2] != null) {
          result.hasZ = true;
        }

        result.spatialReference = spatialReference;
        break;

      case 'Polygon':
        result.rings = orientRings(geojson.coordinates.slice(0));

        if (geojson.coordinates[0][0][2] != null) {
          result.hasZ = true;
        }

        result.spatialReference = spatialReference;
        break;

      case 'MultiPolygon':
        result.rings = flattenMultiPolygonRings(geojson.coordinates.slice(0));

        if (geojson.coordinates[0][0][0][2] != null) {
          result.hasZ = true;
        }

        result.spatialReference = spatialReference;
        break;

      case 'Feature':
        if (geojson.geometry) {
          result.geometry = geojsonToArcGIS(geojson.geometry, idAttribute);
        }

        result.attributes = geojson.properties ? shallowClone(geojson.properties) : {};

        if (geojson.id) {
          result.attributes[idAttribute] = geojson.id;
        }

        break;

      case 'FeatureCollection':
        result = [];

        for (i = 0; i < geojson.features.length; i++) {
          result.push(geojsonToArcGIS(geojson.features[i], idAttribute));
        }

        break;

      case 'GeometryCollection':
        result = [];

        for (i = 0; i < geojson.geometries.length; i++) {
          result.push(geojsonToArcGIS(geojson.geometries[i], idAttribute));
        }

        break;
    }

    return result;
  };

  var POWERED_BY_ESRI_ATTRIBUTION_STRING = 'Powered by <a href="https://www.esri.com">Esri</a>';

  function geojsonToArcGIS (geojson, idAttr) {
    return geojsonToArcGIS$1(geojson, idAttr);
  }

  function arcgisToGeoJSON (arcgis, idAttr) {
    return arcgisToGeoJSON$1(arcgis, idAttr);
  }

  // convert an extent (ArcGIS) to LatLngBounds (Leaflet)
  function extentToBounds (extent) {
    // "NaN" coordinates from ArcGIS Server indicate a null geometry
    if (extent.xmin !== 'NaN' && extent.ymin !== 'NaN' && extent.xmax !== 'NaN' && extent.ymax !== 'NaN') {
      var sw = L.latLng(extent.ymin, extent.xmin);
      var ne = L.latLng(extent.ymax, extent.xmax);
      return L.latLngBounds(sw, ne);
    } else {
      return null;
    }
  }

  // convert an LatLngBounds (Leaflet) to extent (ArcGIS)
  function boundsToExtent (bounds) {
    bounds = L.latLngBounds(bounds);
    return {
      xmin: bounds.getSouthWest().lng,
      ymin: bounds.getSouthWest().lat,
      xmax: bounds.getNorthEast().lng,
      ymax: bounds.getNorthEast().lat,
      spatialReference: {
        wkid: 4326
      }
    };
  }

  var knownFieldNames = /^(OBJECTID|FID|OID|ID)$/i;

  // Attempts to find the ID Field from response
  function _findIdAttributeFromResponse (response) {
    var result;

    if (response.objectIdFieldName) {
      // Find Id Field directly
      result = response.objectIdFieldName;
    } else if (response.fields) {
      // Find ID Field based on field type
      for (var j = 0; j <= response.fields.length - 1; j++) {
        if (response.fields[j].type === 'esriFieldTypeOID') {
          result = response.fields[j].name;
          break;
        }
      }
      if (!result) {
        // If no field was marked as being the esriFieldTypeOID try well known field names
        for (j = 0; j <= response.fields.length - 1; j++) {
          if (response.fields[j].name.match(knownFieldNames)) {
            result = response.fields[j].name;
            break;
          }
        }
      }
    }
    return result;
  }

  // This is the 'last' resort, find the Id field from the specified feature
  function _findIdAttributeFromFeature (feature) {
    for (var key in feature.attributes) {
      if (key.match(knownFieldNames)) {
        return key;
      }
    }
  }

  function responseToFeatureCollection (response, idAttribute) {
    var objectIdField;
    var features = response.features || response.results;
    var count = features && features.length;

    if (idAttribute) {
      objectIdField = idAttribute;
    } else {
      objectIdField = _findIdAttributeFromResponse(response);
    }

    var featureCollection = {
      type: 'FeatureCollection',
      features: []
    };

    if (count) {
      for (var i = features.length - 1; i >= 0; i--) {
        var feature = arcgisToGeoJSON(features[i], objectIdField || _findIdAttributeFromFeature(features[i]));
        featureCollection.features.push(feature);
      }
    }

    return featureCollection;
  }

  // trim url whitespace and add a trailing slash if needed
  function cleanUrl (url) {
    // trim leading and trailing spaces, but not spaces inside the url
    url = L.Util.trim(url);

    // add a trailing slash to the url if the user omitted it
    if (url[url.length - 1] !== '/') {
      url += '/';
    }

    return url;
  }

  /* Extract url params if any and store them in requestParams attribute.
     Return the options params updated */
  function getUrlParams (options) {
    if (options.url.indexOf('?') !== -1) {
      options.requestParams = options.requestParams || {};
      var queryString = options.url.substring(options.url.indexOf('?') + 1);
      options.url = options.url.split('?')[0];
      options.requestParams = JSON.parse('{"' + decodeURI(queryString).replace(/"/g, '\\"').replace(/&/g, '","').replace(/=/g, '":"') + '"}');
    }
    options.url = cleanUrl(options.url.split('?')[0]);
    return options;
  }

  function isArcgisOnline (url) {
    /* hosted feature services support geojson as an output format
    utility.arcgis.com services are proxied from a variety of ArcGIS Server vintages, and may not */
    return (/^(?!.*utility\.arcgis\.com).*\.arcgis\.com.*FeatureServer/i).test(url);
  }

  function geojsonTypeToArcGIS (geoJsonType) {
    var arcgisGeometryType;
    switch (geoJsonType) {
      case 'Point':
        arcgisGeometryType = 'esriGeometryPoint';
        break;
      case 'MultiPoint':
        arcgisGeometryType = 'esriGeometryMultipoint';
        break;
      case 'LineString':
        arcgisGeometryType = 'esriGeometryPolyline';
        break;
      case 'MultiLineString':
        arcgisGeometryType = 'esriGeometryPolyline';
        break;
      case 'Polygon':
        arcgisGeometryType = 'esriGeometryPolygon';
        break;
      case 'MultiPolygon':
        arcgisGeometryType = 'esriGeometryPolygon';
        break;
    }

    return arcgisGeometryType;
  }

  function calcAttributionWidth (map) {
    // either crop at 55px or user defined buffer
    return (map.getSize().x - options.attributionWidthOffset) + 'px';
  }

  function setEsriAttribution (map) {
    if (!map.attributionControl) {
      return;
    }

    if (!map.attributionControl._esriAttributionLayerCount) {
      map.attributionControl._esriAttributionLayerCount = 0;
    }

    if (map.attributionControl._esriAttributionLayerCount === 0) {
      // Dynamically creating the CSS rules, only run this once per page load:
      if (!map.attributionControl._esriAttributionAddedOnce) {
        var hoverAttributionStyle = document.createElement('style');
        hoverAttributionStyle.type = 'text/css';
        hoverAttributionStyle.innerHTML = '.esri-truncated-attribution:hover {' +
          'white-space: normal;' +
        '}';
        document.getElementsByTagName('head')[0].appendChild(hoverAttributionStyle);

        // define a new css class in JS to trim attribution into a single line
        var attributionStyle = document.createElement('style');
        attributionStyle.type = 'text/css';
        attributionStyle.innerHTML = '.esri-truncated-attribution {' +
          'vertical-align: -3px;' +
          'white-space: nowrap;' +
          'overflow: hidden;' +
          'text-overflow: ellipsis;' +
          'display: inline-block;' +
          'transition: 0s white-space;' +
          'transition-delay: 1s;' +
          'max-width: ' + calcAttributionWidth(map) + ';' +
        '}';
        document.getElementsByTagName('head')[0].appendChild(attributionStyle);

        // update the width used to truncate when the map itself is resized
        map.on('resize', function (e) {
          if (map.attributionControl) {
            map.attributionControl._container.style.maxWidth = calcAttributionWidth(e.target);
          }
        });

        map.attributionControl._esriAttributionAddedOnce = true;
      }

      L.DomUtil.addClass(map.attributionControl._container, 'esri-truncated-attribution:hover');
      L.DomUtil.addClass(map.attributionControl._container, 'esri-truncated-attribution');
    }

    // Track the number of esri-leaflet layers that are on the map so we can know when we can remove the attribution (below in removeEsriAttribution)
    map.attributionControl._esriAttributionLayerCount = map.attributionControl._esriAttributionLayerCount + 1;
  }

  function removeEsriAttribution (map) {
    if (!map.attributionControl) {
      return;
    }

    // Only remove the attribution if we're about to remove the LAST esri-leaflet layer (_esriAttributionLayerCount)
    if (map.attributionControl._esriAttributionLayerCount && map.attributionControl._esriAttributionLayerCount === 1) {
      L.DomUtil.removeClass(map.attributionControl._container, 'esri-truncated-attribution:hover');
      L.DomUtil.removeClass(map.attributionControl._container, 'esri-truncated-attribution');
    }
    map.attributionControl._esriAttributionLayerCount = map.attributionControl._esriAttributionLayerCount - 1;
  }

  function _setGeometry (geometry) {
    var params = {
      geometry: null,
      geometryType: null
    };

    // convert bounds to extent and finish
    if (geometry instanceof L.LatLngBounds) {
      // set geometry + geometryType
      params.geometry = boundsToExtent(geometry);
      params.geometryType = 'esriGeometryEnvelope';
      return params;
    }

    // convert L.Marker > L.LatLng
    if (geometry.getLatLng) {
      geometry = geometry.getLatLng();
    }

    // convert L.LatLng to a geojson point and continue;
    if (geometry instanceof L.LatLng) {
      geometry = {
        type: 'Point',
        coordinates: [geometry.lng, geometry.lat]
      };
    }

    // handle L.GeoJSON, pull out the first geometry
    if (geometry instanceof L.GeoJSON) {
      // reassign geometry to the GeoJSON value  (we are assuming that only one feature is present)
      geometry = geometry.getLayers()[0].feature.geometry;
      params.geometry = geojsonToArcGIS(geometry);
      params.geometryType = geojsonTypeToArcGIS(geometry.type);
    }

    // Handle L.Polyline and L.Polygon
    if (geometry.toGeoJSON) {
      geometry = geometry.toGeoJSON();
    }

    // handle GeoJSON feature by pulling out the geometry
    if (geometry.type === 'Feature') {
      // get the geometry of the geojson feature
      geometry = geometry.geometry;
    }

    // confirm that our GeoJSON is a point, line or polygon
    if (geometry.type === 'Point' || geometry.type === 'LineString' || geometry.type === 'Polygon' || geometry.type === 'MultiPolygon') {
      params.geometry = geojsonToArcGIS(geometry);
      params.geometryType = geojsonTypeToArcGIS(geometry.type);
      return params;
    }

    // warn the user if we havn't found an appropriate object
    warn('invalid geometry passed to spatial query. Should be L.LatLng, L.LatLngBounds, L.Marker or a GeoJSON Point, Line, Polygon or MultiPolygon object');
  }

  function _getAttributionData (url, map) {
    if (Support.cors) {
      request(url, {}, L.Util.bind(function (error, attributions) {
        if (error) { return; }
        map._esriAttributions = [];
        for (var c = 0; c < attributions.contributors.length; c++) {
          var contributor = attributions.contributors[c];

          for (var i = 0; i < contributor.coverageAreas.length; i++) {
            var coverageArea = contributor.coverageAreas[i];
            var southWest = L.latLng(coverageArea.bbox[0], coverageArea.bbox[1]);
            var northEast = L.latLng(coverageArea.bbox[2], coverageArea.bbox[3]);
            map._esriAttributions.push({
              attribution: contributor.attribution,
              score: coverageArea.score,
              bounds: L.latLngBounds(southWest, northEast),
              minZoom: coverageArea.zoomMin,
              maxZoom: coverageArea.zoomMax
            });
          }
        }

        map._esriAttributions.sort(function (a, b) {
          return b.score - a.score;
        });

        // pass the same argument as the map's 'moveend' event
        var obj = { target: map };
        _updateMapAttribution(obj);
      }, this));
    }
  }

  function _updateMapAttribution (evt) {
    var map = evt.target;
    var oldAttributions = map._esriAttributions;

    if (!map || !map.attributionControl) return;

    var attributionElement = map.attributionControl._container.querySelector('.esri-dynamic-attribution');

    if (attributionElement && oldAttributions) {
      var newAttributions = '';
      var bounds = map.getBounds();
      var wrappedBounds = L.latLngBounds(
        bounds.getSouthWest().wrap(),
        bounds.getNorthEast().wrap()
      );
      var zoom = map.getZoom();

      for (var i = 0; i < oldAttributions.length; i++) {
        var attribution = oldAttributions[i];
        var text = attribution.attribution;

        if (!newAttributions.match(text) && attribution.bounds.intersects(wrappedBounds) && zoom >= attribution.minZoom && zoom <= attribution.maxZoom) {
          newAttributions += (', ' + text);
        }
      }

      newAttributions = POWERED_BY_ESRI_ATTRIBUTION_STRING + ' | ' + newAttributions.substr(2);
      attributionElement.innerHTML = newAttributions;
      attributionElement.style.maxWidth = calcAttributionWidth(map);

      map.fire('attributionupdated', {
        attribution: newAttributions
      });
    }
  }

  var EsriUtil = {
    warn: warn,
    cleanUrl: cleanUrl,
    getUrlParams: getUrlParams,
    isArcgisOnline: isArcgisOnline,
    geojsonTypeToArcGIS: geojsonTypeToArcGIS,
    responseToFeatureCollection: responseToFeatureCollection,
    geojsonToArcGIS: geojsonToArcGIS,
    arcgisToGeoJSON: arcgisToGeoJSON,
    boundsToExtent: boundsToExtent,
    extentToBounds: extentToBounds,
    calcAttributionWidth: calcAttributionWidth,
    setEsriAttribution: setEsriAttribution,
    removeEsriAttribution: removeEsriAttribution,
    _setGeometry: _setGeometry,
    _getAttributionData: _getAttributionData,
    _updateMapAttribution: _updateMapAttribution,
    _findIdAttributeFromFeature: _findIdAttributeFromFeature,
    _findIdAttributeFromResponse: _findIdAttributeFromResponse
  };

  var Task = L.Class.extend({

    options: {
      proxy: false,
      useCors: cors
    },

    // Generate a method for each methodName:paramName in the setters for this task.
    generateSetter: function (param, context) {
      return L.Util.bind(function (value) {
        this.params[param] = value;
        return this;
      }, context);
    },

    initialize: function (endpoint) {
      // endpoint can be either a url (and options) for an ArcGIS Rest Service or an instance of EsriLeaflet.Service
      if (endpoint.request && endpoint.options) {
        this._service = endpoint;
        L.Util.setOptions(this, endpoint.options);
      } else {
        L.Util.setOptions(this, endpoint);
        this.options.url = cleanUrl(endpoint.url);
      }

      // clone default params into this object
      this.params = L.Util.extend({}, this.params || {});

      // generate setter methods based on the setters object implimented a child class
      if (this.setters) {
        for (var setter in this.setters) {
          var param = this.setters[setter];
          this[setter] = this.generateSetter(param, this);
        }
      }
    },

    token: function (token) {
      if (this._service) {
        this._service.authenticate(token);
      } else {
        this.params.token = token;
      }
      return this;
    },

    apikey: function (apikey) {
      return this.token(apikey);
    },

    // ArcGIS Server Find/Identify 10.5+
    format: function (boolean) {
      // use double negative to expose a more intuitive positive method name
      this.params.returnUnformattedValues = !boolean;
      return this;
    },

    request: function (callback, context) {
      if (this.options.requestParams) {
        L.Util.extend(this.params, this.options.requestParams);
      }
      if (this._service) {
        return this._service.request(this.path, this.params, callback, context);
      }

      return this._request('request', this.path, this.params, callback, context);
    },

    _request: function (method, path, params, callback, context) {
      var url = (this.options.proxy) ? this.options.proxy + '?' + this.options.url + path : this.options.url + path;

      if ((method === 'get' || method === 'request') && !this.options.useCors) {
        return Request.get.JSONP(url, params, callback, context);
      }

      return Request[method](url, params, callback, context);
    }
  });

  function task (options) {
    options = getUrlParams(options);
    return new Task(options);
  }

  var Query = Task.extend({
    setters: {
      offset: 'resultOffset',
      limit: 'resultRecordCount',
      fields: 'outFields',
      precision: 'geometryPrecision',
      featureIds: 'objectIds',
      returnGeometry: 'returnGeometry',
      returnM: 'returnM',
      transform: 'datumTransformation',
      token: 'token'
    },

    path: 'query',

    params: {
      returnGeometry: true,
      where: '1=1',
      outSR: 4326,
      outFields: '*'
    },

    // Returns a feature if its shape is wholly contained within the search geometry. Valid for all shape type combinations.
    within: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelContains'; // to the REST api this reads geometry **contains** layer
      return this;
    },

    // Returns a feature if any spatial relationship is found. Applies to all shape type combinations.
    intersects: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelIntersects';
      return this;
    },

    // Returns a feature if its shape wholly contains the search geometry. Valid for all shape type combinations.
    contains: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelWithin'; // to the REST api this reads geometry **within** layer
      return this;
    },

    // Returns a feature if the intersection of the interiors of the two shapes is not empty and has a lower dimension than the maximum dimension of the two shapes. Two lines that share an endpoint in common do not cross. Valid for Line/Line, Line/Area, Multi-point/Area, and Multi-point/Line shape type combinations.
    crosses: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelCrosses';
      return this;
    },

    // Returns a feature if the two shapes share a common boundary. However, the intersection of the interiors of the two shapes must be empty. In the Point/Line case, the point may touch an endpoint only of the line. Applies to all combinations except Point/Point.
    touches: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelTouches';
      return this;
    },

    // Returns a feature if the intersection of the two shapes results in an object of the same dimension, but different from both of the shapes. Applies to Area/Area, Line/Line, and Multi-point/Multi-point shape type combinations.
    overlaps: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelOverlaps';
      return this;
    },

    // Returns a feature if the envelope of the two shapes intersects.
    bboxIntersects: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelEnvelopeIntersects';
      return this;
    },

    // if someone can help decipher the ArcObjects explanation and translate to plain speak, we should mention this method in the doc
    indexIntersects: function (geometry) {
      this._setGeometryParams(geometry);
      this.params.spatialRel = 'esriSpatialRelIndexIntersects'; // Returns a feature if the envelope of the query geometry intersects the index entry for the target geometry
      return this;
    },

    // only valid for Feature Services running on ArcGIS Server 10.3+ or ArcGIS Online
    nearby: function (latlng, radius) {
      latlng = L.latLng(latlng);
      this.params.geometry = [latlng.lng, latlng.lat];
      this.params.geometryType = 'esriGeometryPoint';
      this.params.spatialRel = 'esriSpatialRelIntersects';
      this.params.units = 'esriSRUnit_Meter';
      this.params.distance = radius;
      this.params.inSR = 4326;
      return this;
    },

    where: function (string) {
      // instead of converting double-quotes to single quotes, pass as is, and provide a more informative message if a 400 is encountered
      this.params.where = string;
      return this;
    },

    between: function (start, end) {
      this.params.time = [start.valueOf(), end.valueOf()];
      return this;
    },

    simplify: function (map, factor) {
      var mapWidth = Math.abs(map.getBounds().getWest() - map.getBounds().getEast());
      this.params.maxAllowableOffset = (mapWidth / map.getSize().y) * factor;
      return this;
    },

    orderBy: function (fieldName, order) {
      order = order || 'ASC';
      this.params.orderByFields = (this.params.orderByFields) ? this.params.orderByFields + ',' : '';
      this.params.orderByFields += ([fieldName, order]).join(' ');
      return this;
    },

    run: function (callback, context) {
      this._cleanParams();

      // services hosted on ArcGIS Online and ArcGIS Server 10.3.1+ support requesting geojson directly
      if (this.options.isModern || (isArcgisOnline(this.options.url) && this.options.isModern === undefined)) {
        this.params.f = 'geojson';

        return this.request(function (error, response) {
          this._trapSQLerrors(error);
          callback.call(context, error, response, response);
        }, this);

        // otherwise convert it in the callback then pass it on
      } else {
        return this.request(function (error, response) {
          this._trapSQLerrors(error);
          callback.call(context, error, (response && responseToFeatureCollection(response)), response);
        }, this);
      }
    },

    count: function (callback, context) {
      this._cleanParams();
      this.params.returnCountOnly = true;
      return this.request(function (error, response) {
        callback.call(this, error, (response && response.count), response);
      }, context);
    },

    ids: function (callback, context) {
      this._cleanParams();
      this.params.returnIdsOnly = true;
      return this.request(function (error, response) {
        callback.call(this, error, (response && response.objectIds), response);
      }, context);
    },

    // only valid for Feature Services running on ArcGIS Server 10.3+ or ArcGIS Online
    bounds: function (callback, context) {
      this._cleanParams();
      this.params.returnExtentOnly = true;
      return this.request(function (error, response) {
        if (response && response.extent && extentToBounds(response.extent)) {
          callback.call(context, error, extentToBounds(response.extent), response);
        } else {
          error = {
            message: 'Invalid Bounds'
          };
          callback.call(context, error, null, response);
        }
      }, context);
    },

    distinct: function () {
      // geometry must be omitted for queries requesting distinct values
      this.params.returnGeometry = false;
      this.params.returnDistinctValues = true;
      return this;
    },

    // only valid for image services
    pixelSize: function (rawPoint) {
      var castPoint = L.point(rawPoint);
      this.params.pixelSize = [castPoint.x, castPoint.y];
      return this;
    },

    // only valid for map services
    layer: function (layer) {
      this.path = layer + '/query';
      return this;
    },

    _trapSQLerrors: function (error) {
      if (error) {
        if (error.code === '400') {
          warn('one common syntax error in query requests is encasing string values in double quotes instead of single quotes');
        }
      }
    },

    _cleanParams: function () {
      delete this.params.returnIdsOnly;
      delete this.params.returnExtentOnly;
      delete this.params.returnCountOnly;
    },

    _setGeometryParams: function (geometry) {
      this.params.inSR = 4326;
      var converted = _setGeometry(geometry);
      this.params.geometry = converted.geometry;
      this.params.geometryType = converted.geometryType;
    }

  });

  function query (options) {
    return new Query(options);
  }

  var Find = Task.extend({
    setters: {
      // method name > param name
      contains: 'contains',
      text: 'searchText',
      fields: 'searchFields', // denote an array or single string
      spatialReference: 'sr',
      sr: 'sr',
      layers: 'layers',
      returnGeometry: 'returnGeometry',
      maxAllowableOffset: 'maxAllowableOffset',
      precision: 'geometryPrecision',
      dynamicLayers: 'dynamicLayers',
      returnZ: 'returnZ',
      returnM: 'returnM',
      gdbVersion: 'gdbVersion',
      // skipped implementing this (for now) because the REST service implementation isnt consistent between operations
      // 'transform': 'datumTransformations',
      token: 'token'
    },

    path: 'find',

    params: {
      sr: 4326,
      contains: true,
      returnGeometry: true,
      returnZ: true,
      returnM: false
    },

    layerDefs: function (id, where) {
      this.params.layerDefs = (this.params.layerDefs) ? this.params.layerDefs + ';' : '';
      this.params.layerDefs += ([id, where]).join(':');
      return this;
    },

    simplify: function (map, factor) {
      var mapWidth = Math.abs(map.getBounds().getWest() - map.getBounds().getEast());
      this.params.maxAllowableOffset = (mapWidth / map.getSize().y) * factor;
      return this;
    },

    run: function (callback, context) {
      return this.request(function (error, response) {
        callback.call(context, error, (response && responseToFeatureCollection(response)), response);
      }, context);
    }
  });

  function find (options) {
    return new Find(options);
  }

  var Identify = Task.extend({
    path: 'identify',

    between: function (start, end) {
      this.params.time = [start.valueOf(), end.valueOf()];
      return this;
    }
  });

  function identify (options) {
    return new Identify(options);
  }

  var IdentifyFeatures = Identify.extend({
    setters: {
      layers: 'layers',
      precision: 'geometryPrecision',
      tolerance: 'tolerance',
      // skipped implementing this (for now) because the REST service implementation isnt consistent between operations.
      // 'transform': 'datumTransformations'
      returnGeometry: 'returnGeometry'
    },

    params: {
      sr: 4326,
      layers: 'all',
      tolerance: 3,
      returnGeometry: true
    },

    on: function (map) {
      var extent = boundsToExtent(map.getBounds());
      var size = map.getSize();
      this.params.imageDisplay = [size.x, size.y, 96];
      this.params.mapExtent = [extent.xmin, extent.ymin, extent.xmax, extent.ymax];
      return this;
    },

    at: function (geometry) {
      // cast lat, long pairs in raw array form manually
      if (geometry.length === 2) {
        geometry = L.latLng(geometry);
      }
      this._setGeometryParams(geometry);
      return this;
    },

    layerDef: function (id, where) {
      this.params.layerDefs = (this.params.layerDefs) ? this.params.layerDefs + ';' : '';
      this.params.layerDefs += ([id, where]).join(':');
      return this;
    },

    simplify: function (map, factor) {
      var mapWidth = Math.abs(map.getBounds().getWest() - map.getBounds().getEast());
      this.params.maxAllowableOffset = (mapWidth / map.getSize().y) * factor;
      return this;
    },

    run: function (callback, context) {
      return this.request(function (error, response) {
        // immediately invoke with an error
        if (error) {
          callback.call(context, error, undefined, response);

        // ok no error lets just assume we have features...
        } else {
          var featureCollection = responseToFeatureCollection(response);
          response.results = response.results.reverse();
          for (var i = 0; i < featureCollection.features.length; i++) {
            var feature = featureCollection.features[i];
            feature.layerId = response.results[i].layerId;
          }
          callback.call(context, undefined, featureCollection, response);
        }
      });
    },

    _setGeometryParams: function (geometry) {
      var converted = _setGeometry(geometry);
      this.params.geometry = converted.geometry;
      this.params.geometryType = converted.geometryType;
    }
  });

  function identifyFeatures (options) {
    return new IdentifyFeatures(options);
  }

  var IdentifyImage = Identify.extend({
    setters: {
      setMosaicRule: 'mosaicRule',
      setRenderingRule: 'renderingRule',
      setPixelSize: 'pixelSize',
      returnCatalogItems: 'returnCatalogItems',
      returnGeometry: 'returnGeometry'
    },

    params: {
      returnGeometry: false
    },

    at: function (latlng) {
      latlng = L.latLng(latlng);
      this.params.geometry = JSON.stringify({
        x: latlng.lng,
        y: latlng.lat,
        spatialReference: {
          wkid: 4326
        }
      });
      this.params.geometryType = 'esriGeometryPoint';
      return this;
    },

    getMosaicRule: function () {
      return this.params.mosaicRule;
    },

    getRenderingRule: function () {
      return this.params.renderingRule;
    },

    getPixelSize: function () {
      return this.params.pixelSize;
    },

    run: function (callback, context) {
      return this.request(function (error, response) {
        callback.call(context, error, (response && this._responseToGeoJSON(response)), response);
      }, this);
    },

    // get pixel data and return as geoJSON point
    // populate catalog items (if any)
    // merging in any catalogItemVisibilities as a propery of each feature
    _responseToGeoJSON: function (response) {
      var location = response.location;
      var catalogItems = response.catalogItems;
      var catalogItemVisibilities = response.catalogItemVisibilities;
      var geoJSON = {
        pixel: {
          type: 'Feature',
          geometry: {
            type: 'Point',
            coordinates: [location.x, location.y]
          },
          crs: {
            type: 'EPSG',
            properties: {
              code: location.spatialReference.wkid
            }
          },
          properties: {
            OBJECTID: response.objectId,
            name: response.name,
            value: response.value
          },
          id: response.objectId
        }
      };

      if (response.properties && response.properties.Values) {
        geoJSON.pixel.properties.values = response.properties.Values;
      }

      if (catalogItems && catalogItems.features) {
        geoJSON.catalogItems = responseToFeatureCollection(catalogItems);
        if (catalogItemVisibilities && catalogItemVisibilities.length === geoJSON.catalogItems.features.length) {
          for (var i = catalogItemVisibilities.length - 1; i >= 0; i--) {
            geoJSON.catalogItems.features[i].properties.catalogItemVisibility = catalogItemVisibilities[i];
          }
        }
      }
      return geoJSON;
    }

  });

  function identifyImage (params) {
    return new IdentifyImage(params);
  }

  var Service = L.Evented.extend({

    options: {
      proxy: false,
      useCors: cors,
      timeout: 0
    },

    initialize: function (options) {
      options = options || {};
      this._requestQueue = [];
      this._authenticating = false;
      L.Util.setOptions(this, options);
      this.options.url = cleanUrl(this.options.url);
    },

    get: function (path, params, callback, context) {
      return this._request('get', path, params, callback, context);
    },

    post: function (path, params, callback, context) {
      return this._request('post', path, params, callback, context);
    },

    request: function (path, params, callback, context) {
      return this._request('request', path, params, callback, context);
    },

    metadata: function (callback, context) {
      return this._request('get', '', {}, callback, context);
    },

    authenticate: function (token) {
      this._authenticating = false;
      this.options.token = token;
      this._runQueue();
      return this;
    },

    getTimeout: function () {
      return this.options.timeout;
    },

    setTimeout: function (timeout) {
      this.options.timeout = timeout;
    },

    _request: function (method, path, params, callback, context) {
      this.fire('requeststart', {
        url: this.options.url + path,
        params: params,
        method: method
      }, true);

      var wrappedCallback = this._createServiceCallback(method, path, params, callback, context);

      if (this.options.token) {
        params.token = this.options.token;
      }
      if (this.options.requestParams) {
        L.Util.extend(params, this.options.requestParams);
      }
      if (this._authenticating) {
        this._requestQueue.push([method, path, params, callback, context]);
      } else {
        var url = (this.options.proxy) ? this.options.proxy + '?' + this.options.url + path : this.options.url + path;

        if ((method === 'get' || method === 'request') && !this.options.useCors) {
          return Request.get.JSONP(url, params, wrappedCallback, context);
        } else {
          return Request[method](url, params, wrappedCallback, context);
        }
      }
    },

    _createServiceCallback: function (method, path, params, callback, context) {
      return L.Util.bind(function (error, response) {
        if (error && (error.code === 499 || error.code === 498)) {
          this._authenticating = true;

          this._requestQueue.push([method, path, params, callback, context]);

          // fire an event for users to handle and re-authenticate
          this.fire('authenticationrequired', {
            authenticate: L.Util.bind(this.authenticate, this)
          }, true);

          // if the user has access to a callback they can handle the auth error
          error.authenticate = L.Util.bind(this.authenticate, this);
        }

        callback.call(context, error, response);

        if (error) {
          this.fire('requesterror', {
            url: this.options.url + path,
            params: params,
            message: error.message,
            code: error.code,
            method: method
          }, true);
        } else {
          this.fire('requestsuccess', {
            url: this.options.url + path,
            params: params,
            response: response,
            method: method
          }, true);
        }

        this.fire('requestend', {
          url: this.options.url + path,
          params: params,
          method: method
        }, true);
      }, this);
    },

    _runQueue: function () {
      for (var i = this._requestQueue.length - 1; i >= 0; i--) {
        var request = this._requestQueue[i];
        var method = request.shift();
        this[method].apply(this, request);
      }
      this._requestQueue = [];
    }
  });

  function service (options) {
    options = getUrlParams(options);
    return new Service(options);
  }

  var MapService = Service.extend({

    identify: function () {
      return identifyFeatures(this);
    },

    find: function () {
      return find(this);
    },

    query: function () {
      return query(this);
    }

  });

  function mapService (options) {
    return new MapService(options);
  }

  var ImageService = Service.extend({

    query: function () {
      return query(this);
    },

    identify: function () {
      return identifyImage(this);
    }
  });

  function imageService (options) {
    return new ImageService(options);
  }

  var FeatureLayerService = Service.extend({

    options: {
      idAttribute: 'OBJECTID'
    },

    query: function () {
      return query(this);
    },

    addFeature: function (feature, callback, context) {
      this.addFeatures(feature, callback, context);
    },

    addFeatures: function (features, callback, context) {
      var featuresArray = features.features ? features.features : [features];
      for (var i = featuresArray.length - 1; i >= 0; i--) {
        delete featuresArray[i].id;
      }
      features = geojsonToArcGIS(features);
      features = featuresArray.length > 1 ? features : [features];
      return this.post('addFeatures', {
        features: features
      }, function (error, response) {
        // For compatibility reason with former addFeature function,
        // we return the object in the array and not the array itself
        var result = (response && response.addResults) ? response.addResults.length > 1 ? response.addResults : response.addResults[0] : undefined;
        if (callback) {
          callback.call(context, error || response.addResults[0].error, result);
        }
      }, context);
    },

    updateFeature: function (feature, callback, context) {
      this.updateFeatures(feature, callback, context);
    },

    updateFeatures: function (features, callback, context) {
      var featuresArray = features.features ? features.features : [features];
      features = geojsonToArcGIS(features, this.options.idAttribute);
      features = featuresArray.length > 1 ? features : [features];

      return this.post('updateFeatures', {
        features: features
      }, function (error, response) {
        // For compatibility reason with former updateFeature function,
        // we return the object in the array and not the array itself
        var result = (response && response.updateResults) ? response.updateResults.length > 1 ? response.updateResults : response.updateResults[0] : undefined;
        if (callback) {
          callback.call(context, error || response.updateResults[0].error, result);
        }
      }, context);
    },

    deleteFeature: function (id, callback, context) {
      this.deleteFeatures(id, callback, context);
    },

    deleteFeatures: function (ids, callback, context) {
      return this.post('deleteFeatures', {
        objectIds: ids
      }, function (error, response) {
        // For compatibility reason with former deleteFeature function,
        // we return the object in the array and not the array itself
        var result = (response && response.deleteResults) ? response.deleteResults.length > 1 ? response.deleteResults : response.deleteResults[0] : undefined;
        if (callback) {
          callback.call(context, error || response.deleteResults[0].error, result);
        }
      }, context);
    }
  });

  function featureLayerService (options) {
    return new FeatureLayerService(options);
  }

  var tileProtocol = (window.location.protocol !== 'https:') ? 'http:' : 'https:';

  var BasemapLayer = L.TileLayer.extend({
    statics: {
      TILES: {
        Streets: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/World_Street_Map/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            subdomains: ['server', 'services'],
            attribution: 'USGS, NOAA',
            attributionUrl: 'https://static.arcgis.com/attribution/World_Street_Map'
          }
        },
        Topographic: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/World_Topo_Map/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            subdomains: ['server', 'services'],
            attribution: 'USGS, NOAA',
            attributionUrl: 'https://static.arcgis.com/attribution/World_Topo_Map'
          }
        },
        Oceans: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/arcgis/rest/services/Ocean/World_Ocean_Base/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            attribution: 'USGS, NOAA',
            attributionUrl: 'https://static.arcgis.com/attribution/Ocean_Basemap'
          }
        },
        OceansLabels: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/arcgis/rest/services/Ocean/World_Ocean_Reference/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''
          }
        },
        NationalGeographic: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/NatGeo_World_Map/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            attribution: 'National Geographic, DeLorme, HERE, UNEP-WCMC, USGS, NASA, ESA, METI, NRCAN, GEBCO, NOAA, increment P Corp.'
          }
        },
        DarkGray: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Dark_Gray_Base/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            attribution: 'HERE, DeLorme, MapmyIndia, &copy; OpenStreetMap contributors'
          }
        },
        DarkGrayLabels: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Dark_Gray_Reference/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''

          }
        },
        Gray: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Light_Gray_Base/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            attribution: 'HERE, DeLorme, MapmyIndia, &copy; OpenStreetMap contributors'
          }
        },
        GrayLabels: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Canvas/World_Light_Gray_Reference/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 16,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''
          }
        },
        Imagery: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            subdomains: ['server', 'services'],
            attribution: 'DigitalGlobe, GeoEye, i-cubed, USDA, USGS, AEX, Getmapping, Aerogrid, IGN, IGP, swisstopo, and the GIS User Community',
            attributionUrl: 'https://static.arcgis.com/attribution/World_Imagery'
          }
        },
        ImageryLabels: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Reference/World_Boundaries_and_Places/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''
          }
        },
        ImageryTransportation: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Reference/World_Transportation/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''
          }
        },
        ShadedRelief: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/World_Shaded_Relief/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 13,
            subdomains: ['server', 'services'],
            attribution: 'USGS'
          }
        },
        ShadedReliefLabels: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Reference/World_Boundaries_and_Places_Alternate/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 12,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''
          }
        },
        Terrain: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/World_Terrain_Base/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 13,
            subdomains: ['server', 'services'],
            attribution: 'USGS, NOAA'
          }
        },
        TerrainLabels: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/Reference/World_Reference_Overlay/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 13,
            subdomains: ['server', 'services'],
            pane: (pointerEvents) ? 'esri-labels' : 'tilePane',
            attribution: ''
          }
        },
        USATopo: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/ArcGIS/rest/services/USA_Topo_Maps/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 15,
            subdomains: ['server', 'services'],
            attribution: 'USGS, National Geographic Society, i-cubed'
          }
        },
        ImageryClarity: {
          urlTemplate: tileProtocol + '//clarity.maptiles.arcgis.com/arcgis/rest/services/World_Imagery/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            attribution: 'Esri, DigitalGlobe, GeoEye, Earthstar Geographics, CNES/Airbus DS, USDA, USGS, AeroGRID, IGN, and the GIS User Community'
          }
        },
        Physical: {
          urlTemplate: tileProtocol + '//{s}.arcgisonline.com/arcgis/rest/services/World_Physical_Map/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 8,
            subdomains: ['server', 'services'],
            attribution: 'U.S. National Park Service'
          }
        },
        ImageryFirefly: {
          urlTemplate: tileProtocol + '//fly.maptiles.arcgis.com/arcgis/rest/services/World_Imagery_Firefly/MapServer/tile/{z}/{y}/{x}',
          options: {
            minZoom: 1,
            maxZoom: 19,
            attribution: 'Esri, DigitalGlobe, GeoEye, Earthstar Geographics, CNES/Airbus DS, USDA, USGS, AeroGRID, IGN, and the GIS User Community',
            attributionUrl: 'https://static.arcgis.com/attribution/World_Imagery'
          }
        }
      }
    },

    initialize: function (key, options) {
      var config;

      // set the config variable with the appropriate config object
      if (typeof key === 'object' && key.urlTemplate && key.options) {
        config = key;
      } else if (typeof key === 'string' && BasemapLayer.TILES[key]) {
        config = BasemapLayer.TILES[key];
      } else {
        throw new Error('L.esri.BasemapLayer: Invalid parameter. Use one of "Streets", "Topographic", "Oceans", "OceansLabels", "NationalGeographic", "Physical", "Gray", "GrayLabels", "DarkGray", "DarkGrayLabels", "Imagery", "ImageryLabels", "ImageryTransportation", "ImageryClarity", "ImageryFirefly", ShadedRelief", "ShadedReliefLabels", "Terrain", "TerrainLabels" or "USATopo"');
      }

      // merge passed options into the config options
      var tileOptions = L.Util.extend(config.options, options);

      L.Util.setOptions(this, tileOptions);

      // Deprecation notice:
      if (!this.options.ignoreDeprecationWarning) {
        console.warn('WARNING: L.esri.BasemapLayer uses data services that are in mature support and are not being updated. Please use L.esri.Vector.vectorBasemapLayer instead. More info: https://esriurl.com/esri-leaflet-basemap');
      }

      if (this.options.token && config.urlTemplate.indexOf('token=') === -1) {
        config.urlTemplate += ('?token=' + this.options.token);
      }
      if (this.options.proxy) {
        config.urlTemplate = this.options.proxy + '?' + config.urlTemplate;
      }

      // call the initialize method on L.TileLayer to set everything up
      L.TileLayer.prototype.initialize.call(this, config.urlTemplate, tileOptions);
    },

    onAdd: function (map) {
      // include 'Powered by Esri' in map attribution
      setEsriAttribution(map);

      if (this.options.pane === 'esri-labels') {
        this._initPane();
      }
      // some basemaps can supply dynamic attribution
      if (this.options.attributionUrl) {
        _getAttributionData((this.options.proxy ? this.options.proxy + '?' : '') + this.options.attributionUrl, map);
      }

      map.on('moveend', _updateMapAttribution);

      L.TileLayer.prototype.onAdd.call(this, map);
    },

    onRemove: function (map) {
      removeEsriAttribution(map);

      map.off('moveend', _updateMapAttribution);

      L.TileLayer.prototype.onRemove.call(this, map);
    },

    _initPane: function () {
      if (!this._map.getPane(this.options.pane)) {
        var pane = this._map.createPane(this.options.pane);
        pane.style.pointerEvents = 'none';
        pane.style.zIndex = 500;
      }
    },

    getAttribution: function () {
      if (this.options.attribution) {
        var attribution = '<span class="esri-dynamic-attribution">' + this.options.attribution + '</span>';
      }
      return attribution;
    }
  });

  function basemapLayer (key, options) {
    return new BasemapLayer(key, options);
  }

  var TiledMapLayer = L.TileLayer.extend({
    options: {
      zoomOffsetAllowance: 0.1,
      errorTileUrl: 'data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAQAAAAEABAMAAACuXLVVAAAAA1BMVEUzNDVszlHHAAAAAXRSTlMAQObYZgAAAAlwSFlzAAAAAAAAAAAB6mUWpAAAADZJREFUeJztwQEBAAAAgiD/r25IQAEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA7waBAAABw08RwAAAAABJRU5ErkJggg=='
    },

    statics: {
      MercatorZoomLevels: {
        0: 156543.03392799999,
        1: 78271.516963999893,
        2: 39135.758482000099,
        3: 19567.879240999901,
        4: 9783.9396204999593,
        5: 4891.9698102499797,
        6: 2445.9849051249898,
        7: 1222.9924525624899,
        8: 611.49622628138002,
        9: 305.74811314055802,
        10: 152.874056570411,
        11: 76.437028285073197,
        12: 38.218514142536598,
        13: 19.109257071268299,
        14: 9.5546285356341496,
        15: 4.7773142679493699,
        16: 2.38865713397468,
        17: 1.1943285668550501,
        18: 0.59716428355981699,
        19: 0.29858214164761698,
        20: 0.14929107082381,
        21: 0.07464553541191,
        22: 0.0373227677059525,
        23: 0.0186613838529763
      }
    },

    initialize: function (options) {
      options = L.Util.setOptions(this, options);

      // set the urls
      options = getUrlParams(options);
      this.tileUrl = (options.proxy ? options.proxy + '?' : '') + options.url + 'tile/{z}/{y}/{x}' + (options.requestParams && Object.keys(options.requestParams).length > 0 ? L.Util.getParamString(options.requestParams) : '');
      // Remove subdomain in url
      // https://github.com/Esri/esri-leaflet/issues/991
      if (options.url.indexOf('{s}') !== -1 && options.subdomains) {
        options.url = options.url.replace('{s}', options.subdomains[0]);
      }
      this.service = mapService(options);
      this.service.addEventParent(this);

      var arcgisonline = new RegExp(/tiles.arcgis(online)?\.com/g);
      if (arcgisonline.test(options.url)) {
        this.tileUrl = this.tileUrl.replace('://tiles', '://tiles{s}');
        options.subdomains = ['1', '2', '3', '4'];
      }

      if (this.options.token) {
        this.tileUrl += ('?token=' + this.options.token);
      }

      // init layer by calling TileLayers initialize method
      L.TileLayer.prototype.initialize.call(this, this.tileUrl, options);
    },

    getTileUrl: function (tilePoint) {
      var zoom = this._getZoomForUrl();

      return L.Util.template(this.tileUrl, L.Util.extend({
        s: this._getSubdomain(tilePoint),
        x: tilePoint.x,
        y: tilePoint.y,
        // try lod map first, then just default to zoom level
        z: (this._lodMap && this._lodMap[zoom] !== undefined) ? this._lodMap[zoom] : zoom
      }, this.options));
    },

    createTile: function (coords, done) {
      var tile = document.createElement('img');

      L.DomEvent.on(tile, 'load', L.Util.bind(this._tileOnLoad, this, done, tile));
      L.DomEvent.on(tile, 'error', L.Util.bind(this._tileOnError, this, done, tile));

      if (this.options.crossOrigin) {
        tile.crossOrigin = '';
      }

      /*
       Alt tag is set to empty string to keep screen readers from reading URL and for compliance reasons
       http://www.w3.org/TR/WCAG20-TECHS/H67
      */
      tile.alt = '';

      // if there is no lod map or an lod map with a proper zoom load the tile
      // otherwise wait for the lod map to become available
      if (!this._lodMap || (this._lodMap && this._lodMap[this._getZoomForUrl()] !== undefined)) {
        tile.src = this.getTileUrl(coords);
      } else {
        this.once('lodmap', function () {
          tile.src = this.getTileUrl(coords);
        }, this);
      }

      return tile;
    },

    onAdd: function (map) {
      // include 'Powered by Esri' in map attribution
      setEsriAttribution(map);

      if (!this._lodMap) {
        this.metadata(function (error, metadata) {
          if (!error && metadata.spatialReference) {
            var sr = metadata.spatialReference.latestWkid || metadata.spatialReference.wkid;
            // display the copyright text from the service using leaflet's attribution control
            if (!this.options.attribution && map.attributionControl && metadata.copyrightText) {
              this.options.attribution = metadata.copyrightText;
              map.attributionControl.addAttribution(this.getAttribution());
            }

            // if the service tiles were published in web mercator using conventional LODs but missing levels, we can try and remap them
            if (map.options.crs === L.CRS.EPSG3857 && (sr === 102100 || sr === 3857)) {
              this._lodMap = {};
              // create the zoom level data
              var arcgisLODs = metadata.tileInfo.lods;
              var correctResolutions = TiledMapLayer.MercatorZoomLevels;

              for (var i = 0; i < arcgisLODs.length; i++) {
                var arcgisLOD = arcgisLODs[i];
                for (var ci in correctResolutions) {
                  var correctRes = correctResolutions[ci];

                  if (this._withinPercentage(arcgisLOD.resolution, correctRes, this.options.zoomOffsetAllowance)) {
                    this._lodMap[ci] = arcgisLOD.level;
                    break;
                  }
                }
              }

              this.fire('lodmap');
            } else if (map.options.crs && map.options.crs.code && (map.options.crs.code.indexOf(sr) > -1)) ; else {
              // if the service was cached in a custom projection and an appropriate LOD hasn't been defined in the map, guide the developer to our Proj4 sample
              warn('L.esri.TiledMapLayer is using a non-mercator spatial reference. Support may be available through Proj4Leaflet https://developers.arcgis.com/esri-leaflet/samples/non-mercator-projection/');
            }
          }
        }, this);
      }

      L.TileLayer.prototype.onAdd.call(this, map);
    },

    onRemove: function (map) {
      removeEsriAttribution(map);

      L.TileLayer.prototype.onRemove.call(this, map);
    },

    metadata: function (callback, context) {
      this.service.metadata(callback, context);
      return this;
    },

    identify: function () {
      return this.service.identify();
    },

    find: function () {
      return this.service.find();
    },

    query: function () {
      return this.service.query();
    },

    authenticate: function (token) {
      var tokenQs = '?token=' + token;
      this.tileUrl = (this.options.token) ? this.tileUrl.replace(/\?token=(.+)/g, tokenQs) : this.tileUrl + tokenQs;
      this.options.token = token;
      this.service.authenticate(token);
      return this;
    },

    _withinPercentage: function (a, b, percentage) {
      var diff = Math.abs((a / b) - 1);
      return diff < percentage;
    }
  });

  function tiledMapLayer (url, options) {
    return new TiledMapLayer(url, options);
  }

  var Overlay = L.ImageOverlay.extend({
    onAdd: function (map) {
      this._topLeft = map.getPixelBounds().min;
      L.ImageOverlay.prototype.onAdd.call(this, map);
    },
    _reset: function () {
      if (this._map.options.crs === L.CRS.EPSG3857) {
        L.ImageOverlay.prototype._reset.call(this);
      } else {
        L.DomUtil.setPosition(this._image, this._topLeft.subtract(this._map.getPixelOrigin()));
      }
    }
  });

  var RasterLayer = L.Layer.extend({
    options: {
      opacity: 1,
      position: 'front',
      f: 'image',
      useCors: cors,
      attribution: null,
      interactive: false,
      alt: ''
    },

    onAdd: function (map) {
      // include 'Powered by Esri' in map attribution
      setEsriAttribution(map);

      if (this.options.zIndex) {
        this.options.position = null;
      }

      this._update = L.Util.throttle(this._update, this.options.updateInterval, this);

      map.on('moveend', this._update, this);

      // if we had an image loaded and it matches the
      // current bounds show the image otherwise remove it
      if (this._currentImage && this._currentImage._bounds.equals(this._map.getBounds())) {
        map.addLayer(this._currentImage);
      } else if (this._currentImage) {
        this._map.removeLayer(this._currentImage);
        this._currentImage = null;
      }

      this._update();

      if (this._popup) {
        this._map.on('click', this._getPopupData, this);
        this._map.on('dblclick', this._resetPopupState, this);
      }

      // add copyright text listed in service metadata
      this.metadata(function (err, metadata) {
        if (!err && !this.options.attribution && map.attributionControl && metadata.copyrightText) {
          this.options.attribution = metadata.copyrightText;
          map.attributionControl.addAttribution(this.getAttribution());
        }
      }, this);
    },

    onRemove: function (map) {
      removeEsriAttribution(map);

      if (this._currentImage) {
        this._map.removeLayer(this._currentImage);
      }

      if (this._popup) {
        this._map.off('click', this._getPopupData, this);
        this._map.off('dblclick', this._resetPopupState, this);
      }

      this._map.off('moveend', this._update, this);
    },

    bindPopup: function (fn, popupOptions) {
      this._shouldRenderPopup = false;
      this._lastClick = false;
      this._popup = L.popup(popupOptions);
      this._popupFunction = fn;
      if (this._map) {
        this._map.on('click', this._getPopupData, this);
        this._map.on('dblclick', this._resetPopupState, this);
      }
      return this;
    },

    unbindPopup: function () {
      if (this._map) {
        this._map.closePopup(this._popup);
        this._map.off('click', this._getPopupData, this);
        this._map.off('dblclick', this._resetPopupState, this);
      }
      this._popup = false;
      return this;
    },

    bringToFront: function () {
      this.options.position = 'front';
      if (this._currentImage) {
        this._currentImage.bringToFront();
        this._setAutoZIndex(Math.max);
      }
      return this;
    },

    bringToBack: function () {
      this.options.position = 'back';
      if (this._currentImage) {
        this._currentImage.bringToBack();
        this._setAutoZIndex(Math.min);
      }
      return this;
    },

    setZIndex: function (value) {
      this.options.zIndex = value;
      if (this._currentImage) {
        this._currentImage.setZIndex(value);
      }
      return this;
    },

    _setAutoZIndex: function (compare) {
      // go through all other layers of the same pane, set zIndex to max + 1 (front) or min - 1 (back)
      if (!this._currentImage) {
        return;
      }
      var layers = this._currentImage.getPane().children;
      var edgeZIndex = -compare(-Infinity, Infinity); // -Infinity for max, Infinity for min
      for (var i = 0, len = layers.length, zIndex; i < len; i++) {
        zIndex = layers[i].style.zIndex;
        if (layers[i] !== this._currentImage._image && zIndex) {
          edgeZIndex = compare(edgeZIndex, +zIndex);
        }
      }

      if (isFinite(edgeZIndex)) {
        this.options.zIndex = edgeZIndex + compare(-1, 1);
        this.setZIndex(this.options.zIndex);
      }
    },

    getAttribution: function () {
      return this.options.attribution;
    },

    getOpacity: function () {
      return this.options.opacity;
    },

    setOpacity: function (opacity) {
      this.options.opacity = opacity;
      if (this._currentImage) {
        this._currentImage.setOpacity(opacity);
      }
      return this;
    },

    getTimeRange: function () {
      return [this.options.from, this.options.to];
    },

    setTimeRange: function (from, to) {
      this.options.from = from;
      this.options.to = to;
      this._update();
      return this;
    },

    metadata: function (callback, context) {
      this.service.metadata(callback, context);
      return this;
    },

    authenticate: function (token) {
      this.service.authenticate(token);
      return this;
    },

    redraw: function () {
      this._update();
    },

    _renderImage: function (url, bounds, contentType) {
      if (this._map) {
        // if no output directory has been specified for a service, MIME data will be returned
        if (contentType) {
          url = 'data:' + contentType + ';base64,' + url;
        }

        // if server returns an inappropriate response, abort.
        if (!url) return;

        // create a new image overlay and add it to the map
        // to start loading the image
        // opacity is 0 while the image is loading
        var image = new Overlay(url, bounds, {
          opacity: 0,
          crossOrigin: this.options.withCredentials ? 'use-credentials' : this.options.useCors,
          alt: this.options.alt,
          pane: this.options.pane || this.getPane(),
          interactive: this.options.interactive
        }).addTo(this._map);

        var onOverlayError = function () {
          this._map.removeLayer(image);
          this.fire('error');
          image.off('load', onOverlayLoad, this);
        };

        var onOverlayLoad = function (e) {
          image.off('error', onOverlayError, this);
          if (this._map) {
            var newImage = e.target;
            var oldImage = this._currentImage;

            // if the bounds of this image matches the bounds that
            // _renderImage was called with and we have a map with the same bounds
            // hide the old image if there is one and set the opacity
            // of the new image otherwise remove the new image
            if (newImage._bounds.equals(bounds) && newImage._bounds.equals(this._map.getBounds())) {
              this._currentImage = newImage;

              if (this.options.position === 'front') {
                this.bringToFront();
              } else if (this.options.position === 'back') {
                this.bringToBack();
              }

              if (this.options.zIndex) {
                this.setZIndex(this.options.zIndex);
              }

              if (this._map && this._currentImage._map) {
                this._currentImage.setOpacity(this.options.opacity);
              } else {
                this._currentImage._map.removeLayer(this._currentImage);
              }

              if (oldImage && this._map) {
                this._map.removeLayer(oldImage);
              }

              if (oldImage && oldImage._map) {
                oldImage._map.removeLayer(oldImage);
              }
            } else {
              this._map.removeLayer(newImage);
            }
          }

          this.fire('load', {
            bounds: bounds
          });
        };

        // If loading the image fails
        image.once('error', onOverlayError, this);

        // once the image loads
        image.once('load', onOverlayLoad, this);
      }
    },

    _update: function () {
      if (!this._map) {
        return;
      }

      var zoom = this._map.getZoom();
      var bounds = this._map.getBounds();

      if (this._animatingZoom) {
        return;
      }

      if (this._map._panTransition && this._map._panTransition._inProgress) {
        return;
      }

      if (zoom > this.options.maxZoom || zoom < this.options.minZoom) {
        if (this._currentImage) {
          this._currentImage._map.removeLayer(this._currentImage);
          this._currentImage = null;
        }
        return;
      }

      var params = this._buildExportParams();
      L.Util.extend(params, this.options.requestParams);

      if (params) {
        this._requestExport(params, bounds);

        this.fire('loading', {
          bounds: bounds
        });
      } else if (this._currentImage) {
        this._currentImage._map.removeLayer(this._currentImage);
        this._currentImage = null;
      }
    },

    _renderPopup: function (latlng, error, results, response) {
      latlng = L.latLng(latlng);
      if (this._shouldRenderPopup && this._lastClick.equals(latlng)) {
        // add the popup to the map where the mouse was clicked at
        var content = this._popupFunction(error, results, response);
        if (content) {
          this._popup.setLatLng(latlng).setContent(content).openOn(this._map);
        }
      }
    },

    _resetPopupState: function (e) {
      this._shouldRenderPopup = false;
      this._lastClick = e.latlng;
    },

    _calculateBbox: function () {
      var pixelBounds = this._map.getPixelBounds();

      var sw = this._map.unproject(pixelBounds.getBottomLeft());
      var ne = this._map.unproject(pixelBounds.getTopRight());

      var neProjected = this._map.options.crs.project(ne);
      var swProjected = this._map.options.crs.project(sw);

      // this ensures ne/sw are switched in polar maps where north/top bottom/south is inverted
      var boundsProjected = L.bounds(neProjected, swProjected);

      return [boundsProjected.getBottomLeft().x, boundsProjected.getBottomLeft().y, boundsProjected.getTopRight().x, boundsProjected.getTopRight().y].join(',');
    },

    _calculateImageSize: function () {
      // ensure that we don't ask ArcGIS Server for a taller image than we have actual map displaying within the div
      var bounds = this._map.getPixelBounds();
      var size = this._map.getSize();

      var sw = this._map.unproject(bounds.getBottomLeft());
      var ne = this._map.unproject(bounds.getTopRight());

      var top = this._map.latLngToLayerPoint(ne).y;
      var bottom = this._map.latLngToLayerPoint(sw).y;

      if (top > 0 || bottom < size.y) {
        size.y = bottom - top;
      }

      return size.x + ',' + size.y;
    }
  });

  var ImageMapLayer = RasterLayer.extend({

    options: {
      updateInterval: 150,
      format: 'jpgpng',
      transparent: true,
      f: 'image'
    },

    query: function () {
      return this.service.query();
    },

    identify: function () {
      return this.service.identify();
    },

    initialize: function (options) {
      options = getUrlParams(options);
      this.service = imageService(options);
      this.service.addEventParent(this);

      L.Util.setOptions(this, options);
    },

    setPixelType: function (pixelType) {
      this.options.pixelType = pixelType;
      this._update();
      return this;
    },

    getPixelType: function () {
      return this.options.pixelType;
    },

    setBandIds: function (bandIds) {
      if (L.Util.isArray(bandIds)) {
        this.options.bandIds = bandIds.join(',');
      } else {
        this.options.bandIds = bandIds.toString();
      }
      this._update();
      return this;
    },

    getBandIds: function () {
      return this.options.bandIds;
    },

    setNoData: function (noData, noDataInterpretation) {
      if (L.Util.isArray(noData)) {
        this.options.noData = noData.join(',');
      } else {
        this.options.noData = noData.toString();
      }
      if (noDataInterpretation) {
        this.options.noDataInterpretation = noDataInterpretation;
      }
      this._update();
      return this;
    },

    getNoData: function () {
      return this.options.noData;
    },

    getNoDataInterpretation: function () {
      return this.options.noDataInterpretation;
    },

    setRenderingRule: function (renderingRule) {
      this.options.renderingRule = renderingRule;
      this._update();
    },

    getRenderingRule: function () {
      return this.options.renderingRule;
    },

    setMosaicRule: function (mosaicRule) {
      this.options.mosaicRule = mosaicRule;
      this._update();
    },

    getMosaicRule: function () {
      return this.options.mosaicRule;
    },

    _getPopupData: function (e) {
      var callback = L.Util.bind(function (error, results, response) {
        if (error) { return; } // we really can't do anything here but authenticate or requesterror will fire
        setTimeout(L.Util.bind(function () {
          this._renderPopup(e.latlng, error, results, response);
        }, this), 300);
      }, this);

      var identifyRequest = this.identify().at(e.latlng);

      // set mosaic rule for identify task if it is set for layer
      if (this.options.mosaicRule) {
        identifyRequest.setMosaicRule(this.options.mosaicRule);
        // @TODO: force return catalog items too?
      }

      // @TODO: set rendering rule? Not sure,
      // sometimes you want raw pixel values
      // if (this.options.renderingRule) {
      //   identifyRequest.setRenderingRule(this.options.renderingRule);
      // }

      identifyRequest.run(callback);

      // set the flags to show the popup
      this._shouldRenderPopup = true;
      this._lastClick = e.latlng;
    },

    _buildExportParams: function () {
      var sr = parseInt(this._map.options.crs.code.split(':')[1], 10);

      var params = {
        bbox: this._calculateBbox(),
        size: this._calculateImageSize(),
        format: this.options.format,
        transparent: this.options.transparent,
        bboxSR: sr,
        imageSR: sr
      };

      if (this.options.from && this.options.to) {
        params.time = this.options.from.valueOf() + ',' + this.options.to.valueOf();
      }

      if (this.options.pixelType) {
        params.pixelType = this.options.pixelType;
      }

      if (this.options.interpolation) {
        params.interpolation = this.options.interpolation;
      }

      if (this.options.compressionQuality) {
        params.compressionQuality = this.options.compressionQuality;
      }

      if (this.options.bandIds) {
        params.bandIds = this.options.bandIds;
      }

      // 0 is falsy *and* a valid input parameter
      if (this.options.noData === 0 || this.options.noData) {
        params.noData = this.options.noData;
      }

      if (this.options.noDataInterpretation) {
        params.noDataInterpretation = this.options.noDataInterpretation;
      }

      if (this.service.options.token) {
        params.token = this.service.options.token;
      }

      if (this.options.renderingRule) {
        params.renderingRule = JSON.stringify(this.options.renderingRule);
      }

      if (this.options.mosaicRule) {
        params.mosaicRule = JSON.stringify(this.options.mosaicRule);
      }

      return params;
    },

    _requestExport: function (params, bounds) {
      if (this.options.f === 'json') {
        this.service.request('exportImage', params, function (error, response) {
          if (error) { return; } // we really can't do anything here but authenticate or requesterror will fire
          if (this.options.token) {
            response.href += ('?token=' + this.options.token);
          }
          if (this.options.proxy) {
            response.href = this.options.proxy + '?' + response.href;
          }
          this._renderImage(response.href, bounds);
        }, this);
      } else {
        params.f = 'image';
        var fullUrl = this.options.url + 'exportImage' + L.Util.getParamString(params);
        if (this.options.proxy) {
          fullUrl = this.options.proxy + '?' + fullUrl;
        }
        this._renderImage(fullUrl, bounds);
      }
    }
  });

  function imageMapLayer (url, options) {
    return new ImageMapLayer(url, options);
  }

  var DynamicMapLayer = RasterLayer.extend({

    options: {
      updateInterval: 150,
      layers: false,
      layerDefs: false,
      timeOptions: false,
      format: 'png32',
      transparent: true,
      f: 'json'
    },

    initialize: function (options) {
      options = getUrlParams(options);
      this.service = mapService(options);
      this.service.addEventParent(this);

      L.Util.setOptions(this, options);
    },

    getDynamicLayers: function () {
      return this.options.dynamicLayers;
    },

    setDynamicLayers: function (dynamicLayers) {
      this.options.dynamicLayers = dynamicLayers;
      this._update();
      return this;
    },

    getLayers: function () {
      return this.options.layers;
    },

    setLayers: function (layers) {
      this.options.layers = layers;
      this._update();
      return this;
    },

    getLayerDefs: function () {
      return this.options.layerDefs;
    },

    setLayerDefs: function (layerDefs) {
      this.options.layerDefs = layerDefs;
      this._update();
      return this;
    },

    getTimeOptions: function () {
      return this.options.timeOptions;
    },

    setTimeOptions: function (timeOptions) {
      this.options.timeOptions = timeOptions;
      this._update();
      return this;
    },

    query: function () {
      return this.service.query();
    },

    identify: function () {
      return this.service.identify();
    },

    find: function () {
      return this.service.find();
    },

    _getPopupData: function (e) {
      var callback = L.Util.bind(function (error, featureCollection, response) {
        if (error) { return; } // we really can't do anything here but authenticate or requesterror will fire
        setTimeout(L.Util.bind(function () {
          this._renderPopup(e.latlng, error, featureCollection, response);
        }, this), 300);
      }, this);

      var identifyRequest;
      if (this.options.popup) {
        identifyRequest = this.options.popup.on(this._map).at(e.latlng);
      } else {
        identifyRequest = this.identify().on(this._map).at(e.latlng);
      }

      // remove extraneous vertices from response features if it has not already been done
      if (!identifyRequest.params.maxAllowableOffset) {
        identifyRequest.simplify(this._map, 0.5);
      }

      if (!(this.options.popup && this.options.popup.params && this.options.popup.params.layers)) {
        if (this.options.layers) {
          identifyRequest.layers('visible:' + this.options.layers.join(','));
        } else {
          identifyRequest.layers('visible');
        }
      }

      // if present, pass layer ids and sql filters through to the identify task
      if (this.options.layerDefs && typeof this.options.layerDefs !== 'string' && !identifyRequest.params.layerDefs) {
        for (var id in this.options.layerDefs) {
          if (Object.prototype.hasOwnProperty.call(this.options.layerDefs, id)) {
            identifyRequest.layerDef(id, this.options.layerDefs[id]);
          }
        }
      }

      identifyRequest.run(callback);

      // set the flags to show the popup
      this._shouldRenderPopup = true;
      this._lastClick = e.latlng;
    },

    _buildExportParams: function () {
      var sr = parseInt(this._map.options.crs.code.split(':')[1], 10);

      var params = {
        bbox: this._calculateBbox(),
        size: this._calculateImageSize(),
        dpi: 96,
        format: this.options.format,
        transparent: this.options.transparent,
        bboxSR: sr,
        imageSR: sr
      };

      if (this.options.dynamicLayers) {
        params.dynamicLayers = this.options.dynamicLayers;
      }

      if (this.options.layers) {
        if (this.options.layers.length === 0) {
          return;
        } else {
          params.layers = 'show:' + this.options.layers.join(',');
        }
      }

      if (this.options.layerDefs) {
        params.layerDefs = typeof this.options.layerDefs === 'string' ? this.options.layerDefs : JSON.stringify(this.options.layerDefs);
      }

      if (this.options.timeOptions) {
        params.timeOptions = JSON.stringify(this.options.timeOptions);
      }

      if (this.options.from && this.options.to) {
        params.time = this.options.from.valueOf() + ',' + this.options.to.valueOf();
      }

      if (this.service.options.token) {
        params.token = this.service.options.token;
      }

      if (this.options.proxy) {
        params.proxy = this.options.proxy;
      }

      // use a timestamp to bust server cache
      if (this.options.disableCache) {
        params._ts = Date.now();
      }

      return params;
    },

    _requestExport: function (params, bounds) {
      if (this.options.f === 'json') {
        this.service.request('export', params, function (error, response) {
          if (error) { return; } // we really can't do anything here but authenticate or requesterror will fire

          if (this.options.token && response.href) {
            response.href += ('?token=' + this.options.token);
          }
          if (this.options.proxy && response.href) {
            response.href = this.options.proxy + '?' + response.href;
          }
          if (response.href) {
            this._renderImage(response.href, bounds);
          } else {
            this._renderImage(response.imageData, bounds, response.contentType);
          }
        }, this);
      } else {
        params.f = 'image';
        var fullUrl = this.options.url + 'export' + L.Util.getParamString(params);
        if (this.options.proxy) {
          fullUrl = this.options.proxy + '?' + fullUrl;
        }
        this._renderImage(fullUrl, bounds);
      }
    }
  });

  function dynamicMapLayer (url, options) {
    return new DynamicMapLayer(url, options);
  }

  var FeatureGrid = L.Layer.extend({
    // @section
    // @aka GridLayer options
    options: {
      // @option cellSize: Number|Point = 256
      // Width and height of cells in the grid. Use a number if width and height are equal, or `L.point(width, height)` otherwise.
      cellSize: 512,

      // @option updateWhenIdle: Boolean = (depends)
      // Load new cells only when panning ends.
      // `true` by default on mobile browsers, in order to avoid too many requests and keep smooth navigation.
      // `false` otherwise in order to display new cells _during_ panning, since it is easy to pan outside the
      // [`keepBuffer`](#gridlayer-keepbuffer) option in desktop browsers.
      updateWhenIdle: L.Browser.mobile,

      // @option updateInterval: Number = 150
      // Cells will not update more than once every `updateInterval` milliseconds when panning.
      updateInterval: 150,

      // @option noWrap: Boolean = false
      // Whether the layer is wrapped around the antimeridian. If `true`, the
      // GridLayer will only be displayed once at low zoom levels. Has no
      // effect when the [map CRS](#map-crs) doesn't wrap around. Can be used
      // in combination with [`bounds`](#gridlayer-bounds) to prevent requesting
      // cells outside the CRS limits.
      noWrap: false,

      // @option keepBuffer: Number = 1.5
      // When panning the map, keep this many rows and columns of cells before unloading them.
      keepBuffer: 1.5
    },

    initialize: function (options) {
      L.Util.setOptions(this, options);
    },

    onAdd: function (map) {
      this._cells = {};
      this._activeCells = {};
      this._resetView();
      this._update();
    },

    onRemove: function (map) {
      this._removeAllCells();
      this._cellZoom = undefined;
    },

    // @method isLoading: Boolean
    // Returns `true` if any cell in the grid layer has not finished loading.
    isLoading: function () {
      return this._loading;
    },

    // @method redraw: this
    // Causes the layer to clear all the cells and request them again.
    redraw: function () {
      if (this._map) {
        this._removeAllCells();
        this._update();
      }
      return this;
    },

    getEvents: function () {
      var events = {
        viewprereset: this._invalidateAll,
        viewreset: this._resetView,
        zoom: this._resetView,
        moveend: this._onMoveEnd
      };

      if (!this.options.updateWhenIdle) {
        // update cells on move, but not more often than once per given interval
        if (!this._onMove) {
          this._onMove = L.Util.throttle(
            this._onMoveEnd,
            this.options.updateInterval,
            this
          );
        }

        events.move = this._onMove;
      }

      return events;
    },

    // @section Extension methods
    // Layers extending `GridLayer` shall reimplement the following method.
    // @method createCell(coords: Object, done?: Function): HTMLElement
    // Called only internally, must be overridden by classes extending `GridLayer`.
    // Returns the `HTMLElement` corresponding to the given `coords`. If the `done` callback
    // is specified, it must be called when the cell has finished loading and drawing.
    createCell: function () {
      return document.createElement('div');
    },

    removeCell: function () {

    },

    reuseCell: function () {

    },

    cellLeave: function () {

    },

    cellEnter: function () {

    },
    // @section
    // @method getCellSize: Point
    // Normalizes the [cellSize option](#gridlayer-cellsize) into a point. Used by the `createCell()` method.
    getCellSize: function () {
      var s = this.options.cellSize;
      return s instanceof L.Point ? s : new L.Point(s, s);
    },

    _pruneCells: function () {
      if (!this._map) {
        return;
      }

      var key, cell;

      for (key in this._cells) {
        cell = this._cells[key];
        cell.retain = cell.current;
      }

      for (key in this._cells) {
        cell = this._cells[key];
        if (cell.current && !cell.active) {
          var coords = cell.coords;
          if (!this._retainParent(coords.x, coords.y, coords.z, coords.z - 5)) {
            this._retainChildren(coords.x, coords.y, coords.z, coords.z + 2);
          }
        }
      }

      for (key in this._cells) {
        if (!this._cells[key].retain) {
          this._removeCell(key);
        }
      }
    },

    _removeAllCells: function () {
      for (var key in this._cells) {
        this._removeCell(key);
      }
    },

    _invalidateAll: function () {
      this._removeAllCells();

      this._cellZoom = undefined;
    },

    _retainParent: function (x, y, z, minZoom) {
      var x2 = Math.floor(x / 2);
      var y2 = Math.floor(y / 2);
      var z2 = z - 1;
      var coords2 = new L.Point(+x2, +y2);
      coords2.z = +z2;

      var key = this._cellCoordsToKey(coords2);
      var cell = this._cells[key];

      if (cell && cell.active) {
        cell.retain = true;
        return true;
      } else if (cell && cell.loaded) {
        cell.retain = true;
      }

      if (z2 > minZoom) {
        return this._retainParent(x2, y2, z2, minZoom);
      }

      return false;
    },

    _retainChildren: function (x, y, z, maxZoom) {
      for (var i = 2 * x; i < 2 * x + 2; i++) {
        for (var j = 2 * y; j < 2 * y + 2; j++) {
          var coords = new L.Point(i, j);
          coords.z = z + 1;

          var key = this._cellCoordsToKey(coords);
          var cell = this._cells[key];

          if (cell && cell.active) {
            cell.retain = true;
            continue;
          } else if (cell && cell.loaded) {
            cell.retain = true;
          }

          if (z + 1 < maxZoom) {
            this._retainChildren(i, j, z + 1, maxZoom);
          }
        }
      }
    },

    _resetView: function (e) {
      var animating = e && (e.pinch || e.flyTo);

      if (animating) {
        return;
      }

      this._setView(
        this._map.getCenter(),
        this._map.getZoom(),
        animating,
        animating
      );
    },

    _setView: function (center, zoom, noPrune, noUpdate) {
      var cellZoom = Math.round(zoom);

      if (!noUpdate) {
        this._cellZoom = cellZoom;

        if (this._abortLoading) {
          this._abortLoading();
        }

        this._resetGrid();

        if (cellZoom !== undefined) {
          this._update(center);
        }

        if (!noPrune) {
          this._pruneCells();
        }

        // Flag to prevent _updateOpacity from pruning cells during
        // a zoom anim or a pinch gesture
        this._noPrune = !!noPrune;
      }
    },

    _resetGrid: function () {
      var map = this._map;
      var crs = map.options.crs;
      var cellSize = (this._cellSize = this.getCellSize());
      var cellZoom = this._cellZoom;

      var bounds = this._map.getPixelWorldBounds(this._cellZoom);
      if (bounds) {
        this._globalCellRange = this._pxBoundsToCellRange(bounds);
      }

      this._wrapX = crs.wrapLng &&
        !this.options.noWrap && [
        Math.floor(map.project([0, crs.wrapLng[0]], cellZoom).x / cellSize.x),
        Math.ceil(map.project([0, crs.wrapLng[1]], cellZoom).x / cellSize.y)
      ];
      this._wrapY = crs.wrapLat &&
        !this.options.noWrap && [
        Math.floor(map.project([crs.wrapLat[0], 0], cellZoom).y / cellSize.x),
        Math.ceil(map.project([crs.wrapLat[1], 0], cellZoom).y / cellSize.y)
      ];
    },

    _onMoveEnd: function (e) {
      var animating = e && (e.pinch || e.flyTo);

      if (animating || !this._map || this._map._animatingZoom) {
        return;
      }

      this._update();
    },

    _getCelldPixelBounds: function (center) {
      var map = this._map;
      var mapZoom = map._animatingZoom
        ? Math.max(map._animateToZoom, map.getZoom())
        : map.getZoom();
      var scale = map.getZoomScale(mapZoom, this._cellZoom);
      var pixelCenter = map.project(center, this._cellZoom).floor();
      var halfSize = map.getSize().divideBy(scale * 2);

      return new L.Bounds(
        pixelCenter.subtract(halfSize),
        pixelCenter.add(halfSize)
      );
    },

    // Private method to load cells in the grid's active zoom level according to map bounds
    _update: function (center) {
      var map = this._map;
      if (!map) {
        return;
      }
      var zoom = Math.round(map.getZoom());

      if (center === undefined) {
        center = map.getCenter();
      }

      var pixelBounds = this._getCelldPixelBounds(center);
      var cellRange = this._pxBoundsToCellRange(pixelBounds);
      var cellCenter = cellRange.getCenter();
      var queue = [];
      var margin = this.options.keepBuffer;
      var noPruneRange = new L.Bounds(
        cellRange.getBottomLeft().subtract([margin, -margin]),
        cellRange.getTopRight().add([margin, -margin])
      );

      // Sanity check: panic if the cell range contains Infinity somewhere.
      if (
        !(
          isFinite(cellRange.min.x) &&
          isFinite(cellRange.min.y) &&
          isFinite(cellRange.max.x) &&
          isFinite(cellRange.max.y)
        )
      ) {
        throw new Error('Attempted to load an infinite number of cells');
      }

      for (var key in this._cells) {
        var c = this._cells[key].coords;
        if (
          c.z !== this._cellZoom ||
          !noPruneRange.contains(new L.Point(c.x, c.y))
        ) {
          this._cells[key].current = false;
        }
      }

      // _update just loads more cells. If the cell zoom level differs too much
      // from the map's, let _setView reset levels and prune old cells.
      if (Math.abs(zoom - this._cellZoom) > 1) {
        this._setView(center, zoom);
        return;
      }

      // create a queue of coordinates to load cells from
      for (var j = cellRange.min.y; j <= cellRange.max.y; j++) {
        for (var i = cellRange.min.x; i <= cellRange.max.x; i++) {
          var coords = new L.Point(i, j);
          coords.z = this._cellZoom;

          if (!this._isValidCell(coords)) {
            continue;
          }

          var cell = this._cells[this._cellCoordsToKey(coords)];
          if (cell) {
            cell.current = true;
          } else {
            queue.push(coords);
          }
        }
      }

      // sort cell queue to load cells in order of their distance to center
      queue.sort(function (a, b) {
        return a.distanceTo(cellCenter) - b.distanceTo(cellCenter);
      });

      if (queue.length !== 0) {
        // if it's the first batch of cells to load
        if (!this._loading) {
          this._loading = true;
        }

        for (i = 0; i < queue.length; i++) {
          var _key = this._cellCoordsToKey(queue[i]);
          var _coords = this._keyToCellCoords(_key);
          if (this._activeCells[_coords]) {
            this._reuseCell(queue[i]);
          } else {
            this._createCell(queue[i]);
          }
        }
      }
    },

    _isValidCell: function (coords) {
      var crs = this._map.options.crs;

      if (!crs.infinite) {
        // don't load cell if it's out of bounds and not wrapped
        var bounds = this._globalCellRange;
        if (
          (!crs.wrapLng &&
            (coords.x < bounds.min.x || coords.x > bounds.max.x)) ||
          (!crs.wrapLat && (coords.y < bounds.min.y || coords.y > bounds.max.y))
        ) {
          return false;
        }
      }

      if (!this.options.bounds) {
        return true;
      }

      // don't load cell if it doesn't intersect the bounds in options
      var cellBounds = this._cellCoordsToBounds(coords);
      return L.toLatLngBounds(this.options.bounds).overlaps(cellBounds);
    },

    _keyToBounds: function (key) {
      return this._cellCoordsToBounds(this._keyToCellCoords(key));
    },

    _cellCoordsToNwSe: function (coords) {
      var map = this._map;
      var cellSize = this.getCellSize();
      var nwPoint = coords.scaleBy(cellSize);
      var sePoint = nwPoint.add(cellSize);
      var nw = map.unproject(nwPoint, coords.z);
      var se = map.unproject(sePoint, coords.z);

      return [nw, se];
    },

    // converts cell coordinates to its geographical bounds
    _cellCoordsToBounds: function (coords) {
      var bp = this._cellCoordsToNwSe(coords);
      var bounds = new L.LatLngBounds(bp[0], bp[1]);

      if (!this.options.noWrap) {
        bounds = this._map.wrapLatLngBounds(bounds);
      }
      return bounds;
    },
    // converts cell coordinates to key for the cell cache
    _cellCoordsToKey: function (coords) {
      return coords.x + ':' + coords.y + ':' + coords.z;
    },

    // converts cell cache key to coordinates
    _keyToCellCoords: function (key) {
      var k = key.split(':');
      var coords = new L.Point(+k[0], +k[1]);

      coords.z = +k[2];
      return coords;
    },

    _removeCell: function (key) {
      var cell = this._cells[key];

      if (!cell) {
        return;
      }

      var coords = this._keyToCellCoords(key);
      var wrappedCoords = this._wrapCoords(coords);
      var cellBounds = this._cellCoordsToBounds(this._wrapCoords(coords));

      cell.current = false;

      delete this._cells[key];
      this._activeCells[key] = cell;

      this.cellLeave(cellBounds, wrappedCoords, key);

      this.fire('cellleave', {
        key: key,
        coords: wrappedCoords,
        bounds: cellBounds
      });
    },

    _reuseCell: function (coords) {
      var key = this._cellCoordsToKey(coords);

      // save cell in cache
      this._cells[key] = this._activeCells[key];
      this._cells[key].current = true;

      var wrappedCoords = this._wrapCoords(coords);
      var cellBounds = this._cellCoordsToBounds(this._wrapCoords(coords));

      this.cellEnter(cellBounds, wrappedCoords, key);

      this.fire('cellenter', {
        key: key,
        coords: wrappedCoords,
        bounds: cellBounds
      });
    },

    _createCell: function (coords) {
      var key = this._cellCoordsToKey(coords);

      var wrappedCoords = this._wrapCoords(coords);
      var cellBounds = this._cellCoordsToBounds(this._wrapCoords(coords));

      this.createCell(cellBounds, wrappedCoords, key);

      this.fire('cellcreate', {
        key: key,
        coords: wrappedCoords,
        bounds: cellBounds
      });

      // save cell in cache
      this._cells[key] = {
        coords: coords,
        current: true
      };

      L.Util.requestAnimFrame(this._pruneCells, this);
    },

    _cellReady: function (coords, err, cell) {
      var key = this._cellCoordsToKey(coords);

      cell = this._cells[key];

      if (!cell) {
        return;
      }

      cell.loaded = +new Date();

      cell.active = true;
    },

    _getCellPos: function (coords) {
      return coords.scaleBy(this.getCellSize());
    },

    _wrapCoords: function (coords) {
      var newCoords = new L.Point(
        this._wrapX ? L.Util.wrapNum(coords.x, this._wrapX) : coords.x,
        this._wrapY ? L.Util.wrapNum(coords.y, this._wrapY) : coords.y
      );
      newCoords.z = coords.z;
      return newCoords;
    },

    _pxBoundsToCellRange: function (bounds) {
      var cellSize = this.getCellSize();
      return new L.Bounds(
        bounds.min.unscaleBy(cellSize).floor(),
        bounds.max.unscaleBy(cellSize).ceil().subtract([1, 1])
      );
    }
  });

  function BinarySearchIndex (values) {
    this.values = [].concat(values || []);
  }

  BinarySearchIndex.prototype.query = function (value) {
    var index = this.getIndex(value);
    return this.values[index];
  };

  BinarySearchIndex.prototype.getIndex = function getIndex (value) {
    if (this.dirty) {
      this.sort();
    }

    var minIndex = 0;
    var maxIndex = this.values.length - 1;
    var currentIndex;
    var currentElement;

    while (minIndex <= maxIndex) {
      currentIndex = (minIndex + maxIndex) / 2 | 0;
      currentElement = this.values[Math.round(currentIndex)];
      if (+currentElement.value < +value) {
        minIndex = currentIndex + 1;
      } else if (+currentElement.value > +value) {
        maxIndex = currentIndex - 1;
      } else {
        return currentIndex;
      }
    }

    return Math.abs(~maxIndex);
  };

  BinarySearchIndex.prototype.between = function between (start, end) {
    var startIndex = this.getIndex(start);
    var endIndex = this.getIndex(end);

    if (startIndex === 0 && endIndex === 0) {
      return [];
    }

    while (this.values[startIndex - 1] && this.values[startIndex - 1].value === start) {
      startIndex--;
    }

    while (this.values[endIndex + 1] && this.values[endIndex + 1].value === end) {
      endIndex++;
    }

    if (this.values[endIndex] && this.values[endIndex].value === end && this.values[endIndex + 1]) {
      endIndex++;
    }

    return this.values.slice(startIndex, endIndex);
  };

  BinarySearchIndex.prototype.insert = function insert (item) {
    this.values.splice(this.getIndex(item.value), 0, item);
    return this;
  };

  BinarySearchIndex.prototype.bulkAdd = function bulkAdd (items, sort) {
    this.values = this.values.concat([].concat(items || []));

    if (sort) {
      this.sort();
    } else {
      this.dirty = true;
    }

    return this;
  };

  BinarySearchIndex.prototype.sort = function sort () {
    this.values.sort(function (a, b) {
      return +b.value - +a.value;
    }).reverse();
    this.dirty = false;
    return this;
  };

  var FeatureManager = FeatureGrid.extend({
    /**
     * Options
     */

    options: {
      attribution: null,
      where: '1=1',
      fields: ['*'],
      from: false,
      to: false,
      timeField: false,
      timeFilterMode: 'server',
      simplifyFactor: 0,
      precision: 6,
      fetchAllFeatures: false
    },

    /**
     * Constructor
     */

    initialize: function (options) {
      FeatureGrid.prototype.initialize.call(this, options);

      options = getUrlParams(options);
      options = L.Util.setOptions(this, options);

      this.service = featureLayerService(options);
      this.service.addEventParent(this);

      // use case insensitive regex to look for common fieldnames used for indexing
      if (this.options.fields[0] !== '*') {
        var oidCheck = false;
        for (var i = 0; i < this.options.fields.length; i++) {
          if (this.options.fields[i].match(/^(OBJECTID|FID|OID|ID)$/i)) {
            oidCheck = true;
          }
        }
        if (oidCheck === false) {
          warn(
            'no known esriFieldTypeOID field detected in fields Array.  Please add an attribute field containing unique IDs to ensure the layer can be drawn correctly.'
          );
        }
      }

      if (this.options.timeField.start && this.options.timeField.end) {
        this._startTimeIndex = new BinarySearchIndex();
        this._endTimeIndex = new BinarySearchIndex();
      } else if (this.options.timeField) {
        this._timeIndex = new BinarySearchIndex();
      }

      this._cache = {};
      this._currentSnapshot = []; // cache of what layers should be active
      this._activeRequests = 0;
    },

    /**
     * Layer Interface
     */

    onAdd: function (map) {
      // include 'Powered by Esri' in map attribution
      setEsriAttribution(map);

      this.service.metadata(function (err, metadata) {
        if (!err) {
          var supportedFormats = metadata.supportedQueryFormats;

          // Check if someone has requested that we don't use geoJSON, even if it's available
          var forceJsonFormat = false;
          if (
            this.service.options.isModern === false ||
            this.options.fetchAllFeatures
          ) {
            forceJsonFormat = true;
          }

          // Unless we've been told otherwise, check to see whether service can emit GeoJSON natively
          if (
            !forceJsonFormat &&
            supportedFormats &&
            supportedFormats.indexOf('geoJSON') !== -1
          ) {
            this.service.options.isModern = true;
          }

          if (metadata.objectIdField) {
            this.service.options.idAttribute = metadata.objectIdField;
          }

          // add copyright text listed in service metadata
          if (
            !this.options.attribution &&
            map.attributionControl &&
            metadata.copyrightText
          ) {
            this.options.attribution = metadata.copyrightText;
            map.attributionControl.addAttribution(this.getAttribution());
          }
        }
      }, this);

      map.on('zoomend', this._handleZoomChange, this);

      return FeatureGrid.prototype.onAdd.call(this, map);
    },

    onRemove: function (map) {
      removeEsriAttribution(map);
      map.off('zoomend', this._handleZoomChange, this);

      return FeatureGrid.prototype.onRemove.call(this, map);
    },

    getAttribution: function () {
      return this.options.attribution;
    },

    /**
     * Feature Management
     */

    createCell: function (bounds, coords) {
      // dont fetch features outside the scale range defined for the layer
      if (this._visibleZoom()) {
        this._requestFeatures(bounds, coords);
      }
    },

    _requestFeatures: function (bounds, coords, callback, offset) {
      this._activeRequests++;

      // default param
      offset = offset || 0;

      var originalWhere = this.options.where;

      // our first active request fires loading
      if (this._activeRequests === 1) {
        this.fire(
          'loading',
          {
            bounds: bounds
          },
          true
        );
      }

      return this._buildQuery(bounds, offset).run(function (
        error,
        featureCollection,
        response
      ) {
        if (response && response.exceededTransferLimit) {
          this.fire('drawlimitexceeded');
        }

        // the where changed while this request was being run so don't it.
        if (this.options.where !== originalWhere) {
          return;
        }

        // no error, features
        if (!error && featureCollection && featureCollection.features.length) {
          // schedule adding features until the next animation frame
          L.Util.requestAnimFrame(
            L.Util.bind(function () {
              this._addFeatures(featureCollection.features, coords);
              this._postProcessFeatures(bounds);
            }, this)
          );
        }

        // no error, no features
        if (!error && featureCollection && !featureCollection.features.length) {
          this._postProcessFeatures(bounds);
        }

        if (error) {
          this._postProcessFeatures(bounds);
        }

        if (callback) {
          callback.call(this, error, featureCollection);
        }
        if (
          response &&
          (response.exceededTransferLimit ||
            (response.properties && response.properties.exceededTransferLimit)) &&
          this.options.fetchAllFeatures
        ) {
          this._requestFeatures(
            bounds,
            coords,
            callback,
            offset + featureCollection.features.length
          );
        }
      },
      this);
    },

    _postProcessFeatures: function (bounds) {
      // deincrement the request counter now that we have processed features
      this._activeRequests--;

      // if there are no more active requests fire a load event for this view
      if (this._activeRequests <= 0) {
        this.fire('load', {
          bounds: bounds
        });
      }
    },

    _cacheKey: function (coords) {
      return coords.z + ':' + coords.x + ':' + coords.y;
    },

    _addFeatures: function (features, coords) {
      // coords is optional - will be false if coming from addFeatures() function
      if (coords) {
        var key = this._cacheKey(coords);
        this._cache[key] = this._cache[key] || [];
      }

      for (var i = features.length - 1; i >= 0; i--) {
        var id = features[i].id;

        if (this._currentSnapshot.indexOf(id) === -1) {
          this._currentSnapshot.push(id);
        }
        if (typeof key !== 'undefined' && this._cache[key].indexOf(id) === -1) {
          this._cache[key].push(id);
        }
      }

      if (this.options.timeField) {
        this._buildTimeIndexes(features);
      }

      this.createLayers(features);
    },

    _buildQuery: function (bounds, offset) {
      var query = this.service
        .query()
        .intersects(bounds)
        .where(this.options.where)
        .fields(this.options.fields)
        .precision(this.options.precision);

      if (this.options.fetchAllFeatures && !isNaN(parseInt(offset))) {
        query = query.offset(offset);
      }

      query.params['resultType'] = 'tile';

      if (this.options.requestParams) {
        L.Util.extend(query.params, this.options.requestParams);
      }

      if (this.options.simplifyFactor) {
        query.simplify(this._map, this.options.simplifyFactor);
      }

      if (
        this.options.timeFilterMode === 'server' &&
        this.options.from &&
        this.options.to
      ) {
        query.between(this.options.from, this.options.to);
      }

      return query;
    },

    /**
     * Where Methods
     */

    setWhere: function (where, callback, context) {
      this.options.where = where && where.length ? where : '1=1';

      var oldSnapshot = [];
      var newSnapshot = [];
      var pendingRequests = 0;
      var requestError = null;
      var requestCallback = L.Util.bind(function (error, featureCollection) {
        if (error) {
          requestError = error;
        }

        if (featureCollection) {
          for (var i = featureCollection.features.length - 1; i >= 0; i--) {
            newSnapshot.push(featureCollection.features[i].id);
          }
        }

        pendingRequests--;

        if (
          pendingRequests <= 0 &&
          this._visibleZoom() &&
          where === this.options.where // the where is still the same so use this one
        ) {
          this._currentSnapshot = newSnapshot;
          // schedule adding features for the next animation frame
          L.Util.requestAnimFrame(
            L.Util.bind(function () {
              this.removeLayers(oldSnapshot);
              this.addLayers(newSnapshot);
              if (callback) {
                callback.call(context, requestError);
              }
            }, this)
          );
        }
      }, this);

      for (var i = this._currentSnapshot.length - 1; i >= 0; i--) {
        oldSnapshot.push(this._currentSnapshot[i]);
      }

      this._cache = {};

      for (var key in this._cells) {
        pendingRequests++;
        var coords = this._keyToCellCoords(key);
        var bounds = this._cellCoordsToBounds(coords);
        this._requestFeatures(bounds, coords, requestCallback);
      }

      return this;
    },

    getWhere: function () {
      return this.options.where;
    },

    /**
     * Time Range Methods
     */

    getTimeRange: function () {
      return [this.options.from, this.options.to];
    },

    setTimeRange: function (from, to, callback, context) {
      var oldFrom = this.options.from;
      var oldTo = this.options.to;
      var pendingRequests = 0;
      var requestError = null;
      var requestCallback = L.Util.bind(function (error) {
        if (error) {
          requestError = error;
        }
        this._filterExistingFeatures(oldFrom, oldTo, from, to);

        pendingRequests--;

        if (callback && pendingRequests <= 0) {
          callback.call(context, requestError);
        }
      }, this);

      this.options.from = from;
      this.options.to = to;

      this._filterExistingFeatures(oldFrom, oldTo, from, to);

      if (this.options.timeFilterMode === 'server') {
        for (var key in this._cells) {
          pendingRequests++;
          var coords = this._keyToCellCoords(key);
          var bounds = this._cellCoordsToBounds(coords);
          this._requestFeatures(bounds, coords, requestCallback);
        }
      }

      return this;
    },

    refresh: function () {
      this.setWhere(this.options.where);
    },

    _filterExistingFeatures: function (oldFrom, oldTo, newFrom, newTo) {
      var layersToRemove =
        oldFrom && oldTo
          ? this._getFeaturesInTimeRange(oldFrom, oldTo)
          : this._currentSnapshot;
      var layersToAdd = this._getFeaturesInTimeRange(newFrom, newTo);

      if (layersToAdd.indexOf) {
        for (var i = 0; i < layersToAdd.length; i++) {
          var shouldRemoveLayer = layersToRemove.indexOf(layersToAdd[i]);
          if (shouldRemoveLayer >= 0) {
            layersToRemove.splice(shouldRemoveLayer, 1);
          }
        }
      }

      // schedule adding features until the next animation frame
      L.Util.requestAnimFrame(
        L.Util.bind(function () {
          this.removeLayers(layersToRemove);
          this.addLayers(layersToAdd);
        }, this)
      );
    },

    _getFeaturesInTimeRange: function (start, end) {
      var ids = [];
      var search;

      if (this.options.timeField.start && this.options.timeField.end) {
        var startTimes = this._startTimeIndex.between(start, end);
        var endTimes = this._endTimeIndex.between(start, end);
        search = startTimes.concat(endTimes);
      } else if (this._timeIndex) {
        search = this._timeIndex.between(start, end);
      } else {
        warn(
          'You must set timeField in the layer constructor in order to manipulate the start and end time filter.'
        );
        return [];
      }

      for (var i = search.length - 1; i >= 0; i--) {
        ids.push(search[i].id);
      }

      return ids;
    },

    _buildTimeIndexes: function (geojson) {
      var i;
      var feature;
      if (this.options.timeField.start && this.options.timeField.end) {
        var startTimeEntries = [];
        var endTimeEntries = [];
        for (i = geojson.length - 1; i >= 0; i--) {
          feature = geojson[i];
          startTimeEntries.push({
            id: feature.id,
            value: new Date(feature.properties[this.options.timeField.start])
          });
          endTimeEntries.push({
            id: feature.id,
            value: new Date(feature.properties[this.options.timeField.end])
          });
        }
        this._startTimeIndex.bulkAdd(startTimeEntries);
        this._endTimeIndex.bulkAdd(endTimeEntries);
      } else {
        var timeEntries = [];
        for (i = geojson.length - 1; i >= 0; i--) {
          feature = geojson[i];
          timeEntries.push({
            id: feature.id,
            value: new Date(feature.properties[this.options.timeField])
          });
        }

        this._timeIndex.bulkAdd(timeEntries);
      }
    },

    _featureWithinTimeRange: function (feature) {
      if (!this.options.from || !this.options.to) {
        return true;
      }

      var from = +this.options.from.valueOf();
      var to = +this.options.to.valueOf();

      if (typeof this.options.timeField === 'string') {
        var date = +feature.properties[this.options.timeField];
        return date >= from && date <= to;
      }

      if (this.options.timeField.start && this.options.timeField.end) {
        var startDate = +feature.properties[this.options.timeField.start];
        var endDate = +feature.properties[this.options.timeField.end];
        return (
          (startDate >= from && startDate <= to) ||
          (endDate >= from && endDate <= to) ||
          (startDate <= from && endDate >= to)
        );
      }
    },

    _visibleZoom: function () {
      // check to see whether the current zoom level of the map is within the optional limit defined for the FeatureLayer
      if (!this._map) {
        return false;
      }
      var zoom = this._map.getZoom();
      if (zoom > this.options.maxZoom || zoom < this.options.minZoom) {
        return false;
      } else {
        return true;
      }
    },

    _handleZoomChange: function () {
      if (!this._visibleZoom()) {
        // if we have moved outside the visible zoom range clear the current snapshot, no layers should be active
        this.removeLayers(this._currentSnapshot);
        this._currentSnapshot = [];
      } else {
        /*
        for every cell in this._cells
          1. Get the cache key for the coords of the cell
          2. If this._cache[key] exists it will be an array of feature IDs.
          3. Call this.addLayers(this._cache[key]) to instruct the feature layer to add the layers back.
        */
        for (var i in this._cells) {
          var coords = this._cells[i].coords;
          var key = this._cacheKey(coords);
          if (this._cache[key]) {
            this.addLayers(this._cache[key]);
          }
        }
      }
    },

    /**
     * Service Methods
     */

    authenticate: function (token) {
      this.service.authenticate(token);
      return this;
    },

    metadata: function (callback, context) {
      this.service.metadata(callback, context);
      return this;
    },

    query: function () {
      return this.service.query();
    },

    _getMetadata: function (callback) {
      if (this._metadata) {
        var error;
        callback(error, this._metadata);
      } else {
        this.metadata(
          L.Util.bind(function (error, response) {
            this._metadata = response;
            callback(error, this._metadata);
          }, this)
        );
      }
    },

    addFeature: function (feature, callback, context) {
      this.addFeatures(feature, callback, context);
    },

    addFeatures: function (features, callback, context) {
      this._getMetadata(
        L.Util.bind(function (error, metadata) {
          if (error) {
            if (callback) {
              callback.call(this, error, null);
            }
            return;
          }
          // GeoJSON featureCollection or simple feature
          var featuresArray = features.features ? features.features : [features];

          this.service.addFeatures(
            features,
            L.Util.bind(function (error, response) {
              if (!error) {
                for (var i = featuresArray.length - 1; i >= 0; i--) {
                  // assign ID from result to appropriate objectid field from service metadata
                  featuresArray[i].properties[metadata.objectIdField] =
                    featuresArray.length > 1
                      ? response[i].objectId
                      : response.objectId;
                  // we also need to update the geojson id for createLayers() to function
                  featuresArray[i].id =
                    featuresArray.length > 1
                      ? response[i].objectId
                      : response.objectId;
                }
                this._addFeatures(featuresArray);
              }

              if (callback) {
                callback.call(context, error, response);
              }
            }, this)
          );
        }, this)
      );
    },

    updateFeature: function (feature, callback, context) {
      this.updateFeatures(feature, callback, context);
    },

    updateFeatures: function (features, callback, context) {
      // GeoJSON featureCollection or simple feature
      var featuresArray = features.features ? features.features : [features];
      this.service.updateFeatures(
        features,
        function (error, response) {
          if (!error) {
            for (var i = featuresArray.length - 1; i >= 0; i--) {
              this.removeLayers([featuresArray[i].id], true);
            }
            this._addFeatures(featuresArray);
          }

          if (callback) {
            callback.call(context, error, response);
          }
        },
        this
      );
    },

    deleteFeature: function (id, callback, context) {
      this.deleteFeatures(id, callback, context);
    },

    deleteFeatures: function (ids, callback, context) {
      return this.service.deleteFeatures(
        ids,
        function (error, response) {
          var responseArray = response.length ? response : [response];
          if (!error && responseArray.length > 0) {
            for (var i = responseArray.length - 1; i >= 0; i--) {
              this.removeLayers([responseArray[i].objectId], true);
            }
          }
          if (callback) {
            callback.call(context, error, response);
          }
        },
        this
      );
    }
  });

  var FeatureLayer = FeatureManager.extend({
    options: {
      cacheLayers: true
    },

    /**
     * Constructor
     */
    initialize: function (options) {
      if (options.apikey) {
        options.token = options.apikey;
      }
      FeatureManager.prototype.initialize.call(this, options);
      this._originalStyle = this.options.style;
      this._layers = {};
    },

    /**
     * Layer Interface
     */

    onRemove: function (map) {
      for (var i in this._layers) {
        map.removeLayer(this._layers[i]);
        // trigger the event when the entire featureLayer is removed from the map
        this.fire(
          'removefeature',
          {
            feature: this._layers[i].feature,
            permanent: false
          },
          true
        );
      }

      return FeatureManager.prototype.onRemove.call(this, map);
    },

    createNewLayer: function (geojson) {
      var layer = L.GeoJSON.geometryToLayer(geojson, this.options);
      // trap for GeoJSON without geometry
      if (layer) {
        layer.defaultOptions = layer.options;
      }
      return layer;
    },

    _updateLayer: function (layer, geojson) {
      // convert the geojson coordinates into a Leaflet LatLng array/nested arrays
      // pass it to setLatLngs to update layer geometries
      var latlngs = [];
      var coordsToLatLng = this.options.coordsToLatLng || L.GeoJSON.coordsToLatLng;

      // copy new attributes, if present
      if (geojson.properties) {
        layer.feature.properties = geojson.properties;
      }

      switch (geojson.geometry.type) {
        case 'Point':
          latlngs = L.GeoJSON.coordsToLatLng(geojson.geometry.coordinates);
          layer.setLatLng(latlngs);
          break;
        case 'LineString':
          latlngs = L.GeoJSON.coordsToLatLngs(
            geojson.geometry.coordinates,
            0,
            coordsToLatLng
          );
          layer.setLatLngs(latlngs);
          break;
        case 'MultiLineString':
          latlngs = L.GeoJSON.coordsToLatLngs(
            geojson.geometry.coordinates,
            1,
            coordsToLatLng
          );
          layer.setLatLngs(latlngs);
          break;
        case 'Polygon':
          latlngs = L.GeoJSON.coordsToLatLngs(
            geojson.geometry.coordinates,
            1,
            coordsToLatLng
          );
          layer.setLatLngs(latlngs);
          break;
        case 'MultiPolygon':
          latlngs = L.GeoJSON.coordsToLatLngs(
            geojson.geometry.coordinates,
            2,
            coordsToLatLng
          );
          layer.setLatLngs(latlngs);
          break;
      }

      // update symbol/style
      this.redraw(layer.feature.id);
    },

    /**
     * Feature Management Methods
     */

    createLayers: function (features) {
      for (var i = features.length - 1; i >= 0; i--) {
        var geojson = features[i];

        var layer = this._layers[geojson.id];
        var newLayer;

        if (
          this._visibleZoom() &&
          layer &&
          !this._map.hasLayer(layer) &&
          (!this.options.timeField || this._featureWithinTimeRange(geojson))
        ) {
          this._map.addLayer(layer);
          this.fire(
            'addfeature',
            {
              feature: layer.feature
            },
            true
          );
        }

        // update geometry if the layer already existed.
        if (layer && (layer.setLatLngs || layer.setLatLng)) {
          this._updateLayer(layer, geojson);
        }

        if (!layer) {
          newLayer = this.createNewLayer(geojson);

          if (!newLayer) {
            warn('invalid GeoJSON encountered');
          } else {
            newLayer.feature = geojson;

            // bubble events from individual layers to the feature layer
            newLayer.addEventParent(this);

            if (this.options.onEachFeature) {
              this.options.onEachFeature(newLayer.feature, newLayer);
            }

            // cache the layer
            this._layers[newLayer.feature.id] = newLayer;

            // style the layer
            this.setFeatureStyle(newLayer.feature.id, this.options.style);

            this.fire(
              'createfeature',
              {
                feature: newLayer.feature
              },
              true
            );

            // add the layer if the current zoom level is inside the range defined for the layer, it is within the current time bounds or our layer is not time enabled
            if (
              this._visibleZoom() &&
              (!this.options.timeField ||
                (this.options.timeField && this._featureWithinTimeRange(geojson)))
            ) {
              this._map.addLayer(newLayer);
            }
          }
        }
      }
    },

    addLayers: function (ids) {
      for (var i = ids.length - 1; i >= 0; i--) {
        var layer = this._layers[ids[i]];
        if (
          layer &&
          (!this.options.timeField || this._featureWithinTimeRange(layer.feature))
        ) {
          this._map.addLayer(layer);
          this.fire(
            'addfeature',
            {
              feature: layer.feature
            },
            true
          );
        }
      }
    },

    removeLayers: function (ids, permanent) {
      for (var i = ids.length - 1; i >= 0; i--) {
        var id = ids[i];
        var layer = this._layers[id];
        if (layer) {
          this.fire(
            'removefeature',
            {
              feature: layer.feature,
              permanent: permanent
            },
            true
          );
          this._map.removeLayer(layer);
        }
        if (layer && permanent) {
          delete this._layers[id];
        }
      }
    },

    cellEnter: function (bounds, coords) {
      if (this._visibleZoom() && !this._zooming && this._map) {
        L.Util.requestAnimFrame(
          L.Util.bind(function () {
            var cacheKey = this._cacheKey(coords);
            var cellKey = this._cellCoordsToKey(coords);
            var layers = this._cache[cacheKey];
            if (this._activeCells[cellKey] && layers) {
              this.addLayers(layers);
            }
          }, this)
        );
      }
    },

    cellLeave: function (bounds, coords) {
      if (!this._zooming) {
        L.Util.requestAnimFrame(
          L.Util.bind(function () {
            if (this._map) {
              var cacheKey = this._cacheKey(coords);
              var cellKey = this._cellCoordsToKey(coords);
              var layers = this._cache[cacheKey];
              var mapBounds = this._map.getBounds();
              if (!this._activeCells[cellKey] && layers) {
                var removable = true;

                for (var i = 0; i < layers.length; i++) {
                  var layer = this._layers[layers[i]];
                  if (
                    layer &&
                    layer.getBounds &&
                    mapBounds.intersects(layer.getBounds())
                  ) {
                    removable = false;
                  }
                }

                if (removable) {
                  this.removeLayers(layers, !this.options.cacheLayers);
                }

                if (!this.options.cacheLayers && removable) {
                  delete this._cache[cacheKey];
                  delete this._cells[cellKey];
                  delete this._activeCells[cellKey];
                }
              }
            }
          }, this)
        );
      }
    },

    /**
     * Styling Methods
     */

    resetStyle: function () {
      this.options.style = this._originalStyle;
      this.eachFeature(function (layer) {
        this.resetFeatureStyle(layer.feature.id);
      }, this);
      return this;
    },

    setStyle: function (style) {
      this.options.style = style;
      this.eachFeature(function (layer) {
        this.setFeatureStyle(layer.feature.id, style);
      }, this);
      return this;
    },

    resetFeatureStyle: function (id) {
      var layer = this._layers[id];
      var style = this._originalStyle || L.Path.prototype.options;
      if (layer) {
        L.Util.extend(layer.options, layer.defaultOptions);
        this.setFeatureStyle(id, style);
      }
      return this;
    },

    setFeatureStyle: function (id, style) {
      var layer = this._layers[id];
      if (typeof style === 'function') {
        style = style(layer.feature);
      }
      if (layer.setStyle) {
        layer.setStyle(style);
      }
      return this;
    },

    /**
     * Utility Methods
     */

    eachActiveFeature: function (fn, context) {
      // figure out (roughly) which layers are in view
      if (this._map) {
        var activeBounds = this._map.getBounds();
        for (var i in this._layers) {
          if (this._currentSnapshot.indexOf(this._layers[i].feature.id) !== -1) {
            // a simple point in poly test for point geometries
            if (
              typeof this._layers[i].getLatLng === 'function' &&
              activeBounds.contains(this._layers[i].getLatLng())
            ) {
              fn.call(context, this._layers[i]);
            } else if (
              typeof this._layers[i].getBounds === 'function' &&
              activeBounds.intersects(this._layers[i].getBounds())
            ) {
              // intersecting bounds check for polyline and polygon geometries
              fn.call(context, this._layers[i]);
            }
          }
        }
      }
      return this;
    },

    eachFeature: function (fn, context) {
      for (var i in this._layers) {
        fn.call(context, this._layers[i]);
      }
      return this;
    },

    getFeature: function (id) {
      return this._layers[id];
    },

    bringToBack: function () {
      this.eachFeature(function (layer) {
        if (layer.bringToBack) {
          layer.bringToBack();
        }
      });
    },

    bringToFront: function () {
      this.eachFeature(function (layer) {
        if (layer.bringToFront) {
          layer.bringToFront();
        }
      });
    },

    redraw: function (id) {
      if (id) {
        this._redraw(id);
      }
      return this;
    },

    _redraw: function (id) {
      var layer = this._layers[id];
      var geojson = layer.feature;

      // if this looks like a marker
      if (layer && layer.setIcon && this.options.pointToLayer) {
        // update custom symbology, if necessary
        if (this.options.pointToLayer) {
          var getIcon = this.options.pointToLayer(
            geojson,
            L.latLng(
              geojson.geometry.coordinates[1],
              geojson.geometry.coordinates[0]
            )
          );
          var updatedIcon = getIcon.options.icon;
          layer.setIcon(updatedIcon);
        }
      }

      // looks like a vector marker (circleMarker)
      if (layer && layer.setStyle && this.options.pointToLayer) {
        var getStyle = this.options.pointToLayer(
          geojson,
          L.latLng(geojson.geometry.coordinates[1], geojson.geometry.coordinates[0])
        );
        var updatedStyle = getStyle.options;
        this.setFeatureStyle(geojson.id, updatedStyle);
      }

      // looks like a path (polygon/polyline)
      if (layer && layer.setStyle && this.options.style) {
        this.resetFeatureStyle(geojson.id);
      }
    },

    // This is the same as the Layer.openPopup method except it excludes the `FeatureGroup`
    // logic to work around https://github.com/Leaflet/Leaflet/issues/8761
    openPopup (latlng) {
      if (this._popup) {
        if (this._popup._prepareOpen(latlng || this._latlng)) {
          // open the popup on the map
          this._popup.openOn(this._map);
        }
      }
      return this;
    },

    // This is the same as the `Layer.openTooltip` method except it excludes the `FeatureGroup`
    // logic to work around https://github.com/Leaflet/Leaflet/issues/8761
    openTooltip (latlng) {
      if (this._tooltip) {
        if (this._tooltip._prepareOpen(latlng)) {
          // open the tooltip on the map
          this._tooltip.openOn(this._map);

          if (this.getElement) {
            this._setAriaDescribedByOnLayer(this);
          } else if (this.eachLayer) {
            this.eachLayer(this._setAriaDescribedByOnLayer, this);
          }
        }
      }
      return this;
    }
  });

  function featureLayer (options) {
    return new FeatureLayer(options);
  }

  // export version
  var version = packageInfo.version;

  var LEsri = {
    __proto__: null,
    VERSION: version,
    Support: Support,
    options: options,
    Util: EsriUtil,
    get: get,
    post: xmlHttpPost,
    request: request,
    Task: Task,
    task: task,
    Query: Query,
    query: query,
    Find: Find,
    find: find,
    Identify: Identify,
    identify: identify,
    IdentifyFeatures: IdentifyFeatures,
    identifyFeatures: identifyFeatures,
    IdentifyImage: IdentifyImage,
    identifyImage: identifyImage,
    Service: Service,
    service: service,
    MapService: MapService,
    mapService: mapService,
    ImageService: ImageService,
    imageService: imageService,
    FeatureLayerService: FeatureLayerService,
    featureLayerService: featureLayerService,
    BasemapLayer: BasemapLayer,
    basemapLayer: basemapLayer,
    TiledMapLayer: TiledMapLayer,
    tiledMapLayer: tiledMapLayer,
    RasterLayer: RasterLayer,
    ImageMapLayer: ImageMapLayer,
    imageMapLayer: imageMapLayer,
    DynamicMapLayer: DynamicMapLayer,
    dynamicMapLayer: dynamicMapLayer,
    FeatureManager: FeatureManager,
    FeatureLayer: FeatureLayer,
    featureLayer: featureLayer
  };

  /**
   * @typedef {Object} ArcGisImageLayer.EventType
   * 当前类支持的{@link EventType}事件类型（包括自定义字符串事件名）
   *
   * @property {String} loading 当新功能开始加载时触发。
   * @property {String} load 当地图当前边界中的所有要素都已加载时触发。
   *
   * @property {String} requeststart 当对服务的请求开始时触发。
   * @property {String} requestend 当对服务的请求结束时触发。
   * @property {String} requestsuccess 当对服务的请求成功时触发。
   * @property {String} requesterror 当对服务的请求响应错误时触发。
   * @property {String} authenticationrequired 当对服务的请求失败并需要身份验证时，这将被触发。
   *
   *
   * @example
   * //绑定监听事件
  tileLayer.on('load', function (event) {
    console.log('触发了事件',event)
  });
   * @see BaseClass#on
   * @see BaseClass#off
   */

  /**
   *
   * ArcGIS Server Image服务图层，
   * 【需要引入mars2d-esri 插件库】
   *
   * @param {Object} options 参数对象，包括以下：
   * @param {String} options.url ArcGIS Server服务地址,比如：'https://sampleserver3.arcgisonline.com/ArcGIS/rest/services/World/MODIS/ImageServer'
   * @param {String} [options.format='jpegpng'] 图像的输出格式
   * @param {Number} [options.opacity=1] 图层的不透明度。应该是介于0(完全透明)和1(完全不透明)之间的值。
   * @param {String} [options.bandIds] 如果有多个波段，您可以指定要导出的波段。
   * @param {Number} [options.noData] 代表无信息的像素值。
   * @param {String} [options.noDataInterpretation] noData设置的解释。
   * @param {String} [options.pixelType] 除非需要，否则在大多数 exportImage 用例中保留pixelType未指定或。
   *
   * @param {Number} [options.minZoom] 图层将显示在地图上的最远缩放级别。
   * @param {Number} [options.maxZoom] 图层将显示在地图上的最近缩放级别。
   * @param {Number} [options.zIndex] 用于图层间排序
   * @param {String} [options.token] 如果您在服务需要传递令牌，它将包含在对服务的所有请求中。
   * @param {String} [options.proxy]  代理服务URL
   * @param {Boolean} [options.useCors=true] 如果此服务在发出 GET 请求时应使用 CORS。
   * @param {String|Number} [options.id = createGuid()] 图层id标识
   * @param {String|Number} [options.pid = -1] 图层父级的id，一般图层管理中使用
   * @param {String} [options.name = ''] 图层名称
   * @param {String} [options.pane = 'tilePane'] 指定图层添加到地图的哪个pane的DIV中，用于控制不同层级显示的，优先级高于zIndex。
   * @export
   * @class ArcGisImageLayer
   * @extends {L.esri.ImageMapLayer}
   * @see [支持的事件类型]{@link ArcGisImageLayer.EventType}
   * @see [更多请参考L.esri.ImageMapLayer类API]{@link http://esri.github.io/esri-leaflet/api-reference/layers/image-map-layer.html}
   * @example
  let arcGisImageLayer = new ArcGisImageLayer({
    url: 'https://ihttmagery.oregonexplorer.info/arcgis/rest/services/NAIP_2011/NAIP_2011_Dynamic/ImageServer'
  })
  arcGisImageLayer.setBandIds('3,0,1').addTo(map);
   */
  class ArcGisImageLayer extends ImageMapLayer {
    initialize(options) {
      var _options$pane, _this$options$id, _this$options$pid, _this$options$show;
      options.pane = (_options$pane = options.pane) !== null && _options$pane !== void 0 ? _options$pane : "tilePane";
      this.options.id = (_this$options$id = this.options.id) !== null && _this$options$id !== void 0 ? _this$options$id : mars2d__namespace.Util.createGuid();
      this.options.pid = (_this$options$pid = this.options.pid) !== null && _this$options$pid !== void 0 ? _this$options$pid : -1;
      this.options.show = (_this$options$show = this.options.show) !== null && _this$options$show !== void 0 ? _this$options$show : true;
      super.initialize(options);
    }

    /**
     * 是否已添加到地图
     *
     * @type {Boolean}
     * @readonly
     *
     */
    get isAdded() {
      return this._map && this._map.hasLayer(this);
    }

    /**
     * 对象的pid标识
     *
     * @type {String|Number}
     */
    get pid() {
      return this.options.pid;
    }
    set pid(pid) {
      this.options.pid = pid;
    }

    /**
     * 对象的id标识
     *
     * @type {String|Number}
     */
    get id() {
      return this.options.id;
    }
    set id(id) {
      this.options.id = id;
    }

    /**
     * 名称 标识
     *
     * @type {String}
     */
    get name() {
      return this.options.name;
    }
    set name(name) {
      this.options.name = name;
    }

    /**
     * 透明度
     *
     * @type {Number}
     */
    get opacity() {
      return this.options.opacity;
    }
    set opacity(value) {
      this.options.opacity = value;
      this.setOpacity(value);
    }

    /**
     * 是否可以调整透明度
     * @type {boolean}
     * @readonly
     */
    get hasOpacity() {
      return true;
    }

    /**
     * 波段值
     * @type {String|Number[]}
     */
    get bandIds() {
      return this.getBandIds();
    }
    set bandIds(value) {
      this.setBandIds(value);
    } /**
      * 显示隐藏状态
      *
      * @type {Boolean}
      */

    get show() {
      return this.options.show;
    }
    set show(show) {
      if (this.options.show === show) {
        return;
      }
      this.options.show = show;
      if (show) {
        if (this._map) {
          this.addTo(this._map);
        }
      } else {
        const map = this._map;
        this.remove();
        this._map = map;
      }
    }
  }
  mars2d__namespace.layer.ArcGisImageLayer = ArcGisImageLayer;

  // 注册下
  mars2d__namespace.LayerUtil.register("arcgis_image", ArcGisImageLayer);

  // 以下是leaflet的内部方法，mars2d集成直接使用的，编写注释形成API文档

  /**
   * 在所有其他叠加层下方重绘此层。
   * @return {ArcGisImageLayer} 当前对象本身,可以链式调用
   *
   * @function bringToBack
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 在所有其他叠加层之上重绘此层。
   * @return {ArcGisImageLayer} 当前对象本身,可以链式调用
   *
   * @function bringToFront
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 绑定Popup弹窗配置
   * @param {Function} content Popup弹窗回调方法
   * @param {Map.PopupOptions|Object} [options] Popup弹窗参数
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   * @example
  imageMapLayer.bindPopup(function(err, identifyResults, response){
      var value = results.pixel.properties.value;
      return (value) ? 'Pixel value: ' + value : false;
    });
   *
   * @function bindPopup
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 解除绑定Popup弹窗配置
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function unbindPopup
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 返回当前波段值。
   * @return {String} 波段值
   *
   * @function getBandIds
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 指定要导出的单个波段，或者您可以通过指定波段编号来更改波段组合（红色、绿色、蓝色）。
   * @param {String|Number[]} bandIds 波段值
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function setBandIds
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 返回当前无数据值。
   * @return {String} 无数据值
   *
   * @function getNoData
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 指定单个值或一组值以将其视为无数据。没有数据将值呈现为透明。
   *
   * @param {Number|Number[]} noData 无数据值
   * @param {String} [noDataInterpretation] 可以是esriNoDataMatchAny| esriNoDataMatchAll.
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function setNoData
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 返回当前像素类型。
   * @return {String} 像素类型也称为数据类型
   *
   * @function getPixelType
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 像素类型也称为数据类型，与存储在栅格中的值的类型有关，例如有符号整数、无符号整数或浮点数。可能的值：C128、C64、F32、F64、S16、S32、S8、U1、U16、U2、U32、U4、U8、UNKNOWN。
   *
   * @param {String} pixelType 像素类型也称为数据类型
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function setPixelType
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 请求有关此要素图层的元数据。将使用error和调用回调metadata。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   * @example
  featureLayer.metadata(function(error, metadata){
    console.log(metadata);
  });
   * @function metadata
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 返回L.esri.Query可用于查询此服务的新对象。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {Object} [L.esri.Query对象]{@link http://esri.github.io/esri-leaflet/api-reference/tasks/query.html}
   * @example
  imageService.query()
    .within(latlngbounds)
    .run(function(error, featureCollection, response){
      console.log(featureCollection);
  });
   * @function query
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 返回图层的当前渲染规则。
   * @return {Object} 当前渲染规则
   *
   * @function getRenderingRule
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 使用传递的渲染规则重绘图层。
   * @param {Object} renderingRule 当前渲染规则
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function setRenderingRule
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 返回图层的当前镶嵌规则。
   * @return {Object} 镶嵌规则
   *
   * @function getMosaicRule
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 使用传递的镶嵌规则重绘图层。
   * @param {Object} mosaicRule 镶嵌规则
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function setMosaicRule
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 用于向服务发出新请求并绘制响应。
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function redraw
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 将图层添加到地图
   * @param {Map} map  地图对象
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function addTo
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * 将图层从地图上移除
   * @return {ArcGisImageLayer} 当前对象本身，可以链式调用
   *
   * @function remove
   * @memberof ArcGisImageLayer
   * @instance
   */

  /**
   * ArcGIS Server 瓦片地图服务图层，
   * 【需要引入mars2d-esri 插件库】
   *
   * @param {Object} options 参数对象，包括以下：
   * @param {String} options.url ArcGIS Server服务地址,比如：'https://sampleserver3.arcgisonline.com/ArcGIS/rest/services/World/MODIS/ImageServer'
   * @param {Number} [options.zoomOffsetAllowance=0.1] 如果启用correctZoomLevels，这将控制重新映射贴图级别的每个缩放级别上的差异的容错量。
   *
   * @param {String} [options.token] 如果您在服务需要传递令牌，它将包含在对服务的所有请求中。
   * @param {String} [options.proxy]  代理服务URL
   * @param {Boolean} [options.useCors=true] 如果此服务在发出 GET 请求时应使用 CORS。
   *
   * @param {Number} [options.opacity=1] 瓦片的不透明度。
   * @param {Number} [options.minZoom=0] 最小的缩放级别
   * @param {Number} [options.maxZoom=18] 最大的缩放级别
   * @param {Number} [options.maxNativeZoom] 瓦片来源可用的最大缩放倍数。如果指定，则所有缩放级别上的图块maxNativeZoom将高于将从maxNativeZoom级别加载并自动缩放。
   * @param {Number} [options.minNativeZoom] 瓦片来源可用的最小缩放数。如果指定，所有缩放级别上的图块minNativeZoom将从minNativeZoom级别加载并自动缩放。
   * @param {Number} [options.zIndex=1] 瓦片层的显式zIndex
   * @param {L.LatLngBounds} [options.bounds] 自定义加载的瓦片矩形范围
   * @param {String} [options.errorTileUrl] 显示加载瓦片失败时，显示的图片的url
   * @param {Boolean} [options.tms] 如果此值为true，反转切片Y轴的编号（对于TMS服务需将此项打开）
   * @param {Boolean} [options.zoomReverse=false] 如果设置为true，则URL网址中使用的缩放z数字将被颠倒（maxZoom - zoom而不是zoom）
   * @param {Number} [options.xOffset] 对URL中地图的缩放级别x值加上xOffset值
   * @param {Number} [options.yOffset] 对URL中地图的缩放级别y值加上yOffset值
   * @param {Number} [options.zOffset] 对URL中地图的缩放级别z值加上zOffset值
   * @param {Function} [options.customTags] 自定义对瓦片请求参数处理
   * @param {Number|L.Point} [options.tileSize=256] 网格中瓦片的宽度和高度。如果宽度和高度相等，则使用数字，否则L.point(width, height)。
   * @param {String} [options.className] 要分配给瓦片图层的自定义类名称
   * @param {Number} [options.keepBuffer=2] 当平移地图时，在卸载它们之前，先保留许多行和列的数据块。
   * @param {Boolean} [options.detectRetina=false] 如果此项为true，并且用户是视网膜显示模式，会请求规定大小一般的四个切片和一个地区内一个更大的缩放级别来利用高分辨率.
   * @param {Boolean} [options.crossOrigin=false] 如果为true，则所有图块将其crossOrigin属性设置为“*”。如果要访问像素数据，则需要这样做。
   * @param {Number} [options.updateInterval=200] 当平移时，updateInterval毫秒不会更新一次瓦片。
   * @param {Boolean} [options.updateWhenZooming=true] 默认情况下，平滑缩放动画（touch zoom 或flyTo()） 会在整个缩放级别更新网格图层。设置此选项false将仅在平滑动画结束时更新网格层。
   * @param {Boolean} [options.noWrap=false] 该层是否在子午线断面。 如果为true，GridLayer只能在低缩放级别显示一次。当地图CRS 不包围时，没有任何效果。 可以结合使用bounds 以防止在CRS限制之外请求瓦片。
   * @param {ChinaCRS} [options.chinaCRS] 标识瓦片的国内坐标系（用于自动纠偏或加偏），自动将瓦片转为map对应的chinaCRS类型坐标系。
   *
   * @param {String|Number} [options.id = createGuid()] 图层id标识
   * @param {String|Number} [options.pid = -1] 图层父级的id，一般图层管理中使用
   * @param {String} [options.name = ''] 图层名称
   * @param {String} [options.pane = 'tilePane'] 指定图层添加到地图的哪个pane的DIV中，用于控制不同层级显示的，优先级高于zIndex。
   * @export
   * @class ArcGisTileLayer
   * @extends {L.esri.TiledMapLayer}
   * @see [支持的事件类型]{@link TileLayer.EventType}
   * @see [更多请参考L.esri.TiledMapLayer类API]{@link http://esri.github.io/esri-leaflet/api-reference/layers/tiled-map-layer.html}
   */
  class ArcGisTileLayer extends TiledMapLayer {
    initialize(options) {
      var _this$options$id, _this$options$pid, _this$options$show;
      super.initialize(options);
      this.options.id = (_this$options$id = this.options.id) !== null && _this$options$id !== void 0 ? _this$options$id : mars2d__namespace.Util.createGuid();
      this.options.pid = (_this$options$pid = this.options.pid) !== null && _this$options$pid !== void 0 ? _this$options$pid : -1;
      this.options.show = (_this$options$show = this.options.show) !== null && _this$options$show !== void 0 ? _this$options$show : true;
    }

    /**
     * 是否已添加到地图
     *
     * @type {Boolean}
     * @readonly
     *
     */
    get isAdded() {
      return this._map && this._map.hasLayer(this);
    }

    /**
     * 对象的pid标识
     *
     * @type {String|Number}
     */
    get pid() {
      return this.options.pid;
    }
    set pid(pid) {
      this.options.pid = pid;
    }

    /**
     * 对象的id标识
     *
     * @type {String|Number}
     */
    get id() {
      return this.options.id;
    }
    set id(id) {
      this.options.id = id;
    }

    /**
     * 名称 标识
     *
     * @type {String}
     */
    get name() {
      return this.options.name;
    }
    set name(name) {
      this.options.name = name;
    }

    /**
     * 显示隐藏状态
     *
     * @type {Boolean}
     */

    get show() {
      return this.options.show;
    }
    set show(show) {
      if (this.options.show === show) {
        return;
      }
      this.options.show = show;
      if (show) {
        if (this._map) {
          this.addTo(this._map);
        }
      } else {
        const map = this._map;
        this.remove();
        this._map = map;
      }
    }

    /**
     * 透明度
     *
     * @type {Number}
     */
    get opacity() {
      return this.options.opacity;
    }
    set opacity(value) {
      this.options.opacity = value;
      this.setOpacity(value);
    }

    /**
     * 是否可以调整透明度
     * @type {boolean}
     * @readonly
     */
    get hasOpacity() {
      return true;
    }
  }
  mars2d__namespace.layer.ArcGisTileLayer = ArcGisTileLayer;

  // 注册下
  mars2d__namespace.LayerUtil.register("arcgis_tile", ArcGisTileLayer);

  // 以下是leaflet的内部方法，mars2d集成直接使用的，编写注释形成API文档

  /**
   * 请求有关此要素图层的元数据。将使用error和调用回调metadata。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisTileLayer} 当前对象本身，可以链式调用
   * @example
  dynamicMapLayer.metadata(function(error, metadata){
    console.log(metadata);
  });
   * @function metadata
   * @memberof ArcGisTileLayer
   * @instance
   */

  /**
   * 返回一个IdentifyFeatures新对象，可用于识别该图层上的要素。您的回调函数将传递一个带有结果或错误的GeoJSON。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {Object} [L.esri.services.IdentifyFeatures对象]{@link http://esri.github.io/esri-leaflet/api-reference/tasks/identify-features.html}
   * @example
  dynamicMapLayer.identify()
    .at(latlng)
    .run(function(error, featureCollection){
      console.log(featureCollection);
    });
   * @function identify
   * @memberof ArcGisTileLayer
   * @instance
   */

  /**
   * 将图层添加到地图
   * @param {Map} map  地图对象
   * @return {ArcGisTileLayer} 当前对象本身，可以链式调用
   *
   * @function addTo
   * @memberof ArcGisTileLayer
   * @instance
   */

  /**
   * 将图层从地图上移除
   * @return {ArcGisTileLayer} 当前对象本身，可以链式调用
   *
   * @function remove
   * @memberof ArcGisTileLayer
   * @instance
   */

  /**
   * @typedef {Object} ArcGisDynamicLayer.EventType
   * 当前类支持的{@link EventType}事件类型（包括自定义字符串事件名）
   *
   * @property {String} loading 当新功能开始加载时触发。
   * @property {String} load 当地图当前边界中的所有要素都已加载时触发。
   *
   * @property {String} requeststart 当对服务的请求开始时触发。
   * @property {String} requestend 当对服务的请求结束时触发。
   * @property {String} requestsuccess 当对服务的请求成功时触发。
   * @property {String} requesterror 当对服务的请求响应错误时触发。
   * @property {String} authenticationrequired 当对服务的请求失败并需要身份验证时，这将被触发。
   *
   *
   * @example
   * //绑定监听事件
  tileLayer.on('load', function (event) {
    console.log('触发了事件',event)
  });
   * @see BaseClass#on
   * @see BaseClass#off
   */

  /**
   *
   * ArcGIS Server 动态服务图层，
   * 【需要引入mars2d-esri 插件库】
   *
   * @param {Object} options 参数对象，包括以下：
   * @param {String} options.url ArcGIS Server服务地址，如：https://sampleserver6.arcgisonline.com/arcgis/rest/services/Hurricanes/MapServer/
   * @param {String[]} [options.layers] 一个层id的数组，显示服务中的指定图层集合。
   * @param {Object} [options.layerDefs] SQL筛选器，以定义服务呈现的图像中包含哪些特性。对象与键一起使用，将每个查询映射到其各自的层。{ 3: "STATE_NAME='Kansas'", 9: "POP2007>25000" }
   * @param {String} [options.format='png24'] 图像的输出格式
   * @param {Boolean} [options.transparent=true] 是否允许服务器产生透明的图像。
   * @param {Number} [options.opacity=1] 图层的不透明度。应该是介于0(完全透明)和1(完全不透明)之间的值。
   * @param {Object} [options.dynamicLayers] 用于覆盖服务定义的图层符号系统的一个或多个 JSON 对象的数组。需要哪些支持10.1+地图服务请求。
   * @param {Boolean} [options.disableCache=false] 如果启用，将时间戳附加到每个请求以确保在服务器端创建新图像。
   * @param {String} [options.popup]  popup弹窗配置
   *
   * @param {Number} [options.minZoom] 图层将显示在地图上的最远缩放级别。
   * @param {Number} [options.maxZoom] 图层将显示在地图上的最近缩放级别。
   * @param {String} [options.token] 如果您在服务需要传递令牌，它将包含在对服务的所有请求中。
   * @param {String} [options.proxy]  代理服务URL
   * @param {Boolean} [options.useCors=true] 如果此服务在发出 GET 请求时应使用 CORS。
   * @param {Number} [options.zIndex] 用于图层间排序
   *
   * @param {String|Number} [options.id = createGuid()] 图层id标识
   * @param {String|Number} [options.pid = -1] 图层父级的id，一般图层管理中使用
   * @param {String} [options.name = ''] 图层名称
   * @param {String} [options.pane = 'tilePane'] 指定图层添加到地图的哪个pane的DIV中，用于控制不同层级显示的，优先级高于zIndex。
   * @export
   * @class ArcGisDynamicLayer
   * @extends {L.esri.DynamicMapLayer}
   * @see [支持的事件类型]{@link ArcGisDynamicLayer.EventType}
   * @see [更多请参考L.esri.DynamicMapLayer类API]{@link http://esri.github.io/esri-leaflet/api-reference/layers/dynamic-map-layer.html}
   */
  class ArcGisDynamicLayer extends DynamicMapLayer {
    /**
     * 是否已添加到地图
     *
     * @type {Boolean}
     * @readonly
     *
     */
    get isAdded() {
      return this._map && this._map.hasLayer(this);
    }

    /**
     * 对象的pid标识
     *
     * @type {String|Number}
     */
    get pid() {
      return this.options.pid;
    }
    set pid(pid) {
      this.options.pid = pid;
    }

    /**
     * 对象的id标识
     *
     * @type {String|Number}
     */
    get id() {
      return this.options.id;
    }
    set id(id) {
      this.options.id = id;
    }

    /**
     * 名称 标识
     *
     * @type {String}
     */
    get name() {
      return this.options.name;
    }
    set name(name) {
      this.options.name = name;
    }

    /**
     * 透明度
     *
     * @type {Number}
     */
    get opacity() {
      return this.options.opacity;
    }
    set opacity(value) {
      this.options.opacity = value;
      this.setOpacity(value);
    }

    /**
     * 是否可以调整透明度
     * @type {boolean}
     * @readonly
     */
    get hasOpacity() {
      return true;
    }

    /**
     * 显示隐藏状态
     *
     * @type {Boolean}
     */
    get show() {
      return this.options.show;
    }
    set show(show) {
      if (this.options.show === show) {
        return;
      }
      this.options.show = show;
      if (show) {
        if (this._map) {
          this.addTo(this._map);
        }
      } else {
        const map = this._map;
        this.remove();
        this._map = map;
      }
    }
    initialize(options) {
      var _options$pane, _this$options$id, _this$options$pid;
      let popupConifg;
      if (options.popup) {
        popupConifg = options.popup;
        delete options.popup;
      }
      options.pane = (_options$pane = options.pane) !== null && _options$pane !== void 0 ? _options$pane : "tilePane";
      // options.show = options.show ?? true

      super.initialize(options);
      L__default["default"].Util.stamp(this);
      this.options.id = (_this$options$id = this.options.id) !== null && _this$options$id !== void 0 ? _this$options$id : mars2d__namespace.Util.createGuid();
      this.options.pid = (_this$options$pid = this.options.pid) !== null && _this$options$pid !== void 0 ? _this$options$pid : -1;
      if (popupConifg) {
        const popupOptions = this.options.popupOptions || {};
        this.bindPopup((error, data, response) => {
          if (error != null && error.code > 0) {
            mars2d__namespace.Util.msg(error.message);
            return false;
          }
          const graphic = data.graphic;
          if (!graphic) {
            return false;
          }
          const attr = graphic.attr;
          let title = this.name;
          if (popupOptions.noTitle) {
            title = null;
          } else if (popupOptions.title) {
            title = popupOptions.title;
          } else if (popupOptions.titleField) {
            title = attr[popupOptions.titleField];
          }
          return mars2d__namespace.Util.getTemplateHtml({
            title: title,
            template: popupConifg,
            attr: attr
          });
        }, {
          maxWidth: 600
        });
      }
    }
    onAdd(map) {
      super.onAdd(map);
      setTimeout(() => {
        if (this._map && !this._popup && (this.highlight || this.listens("click"))) {
          this._map.on("click", this._getPopupData, this);
          this._map.on("dblclick", this._resetPopupState, this);
        }
      }, 1000);
    }
    _renderPopup(latlng, error, results, response) {
      var _this$options;
      const highlightStyle = (_this$options = this.options) === null || _this$options === void 0 ? void 0 : _this$options.highlight;
      const graphicsOptions = mars2d__namespace.Util.geoJsonToGraphics(results, {
        type: highlightStyle === null || highlightStyle === void 0 ? void 0 : highlightStyle.type,
        style: highlightStyle
      });
      const data = {
        layer: this,
        graphic: graphicsOptions.length > 0 ? graphicsOptions[0] : null,
        graphics: graphicsOptions,
        geojson: results,
        latlng: latlng
      };
      if (this._popup) {
        super._renderPopup(latlng, error, data, response);
      }
      if (graphicsOptions && highlightStyle) {
        if (!this._graphicLayer) {
          this._graphicLayer = new mars2d__namespace.layer.GraphicLayer({
            name: "高亮对象图层",
            isPrivate: true
          });
          this._map.addLayer(this._graphicLayer);
        }
        this._graphicLayer.clear();
        this._graphicLayer.addGraphic(graphicsOptions);
        if (this._popup) {
          this._popup._source = this;
          this.once(mars2d__namespace.EventType.popupclose, e => {
            this._graphicLayer.clear();
          });
        }
      }
      if (this.listens("click")) {
        this.fire(mars2d__namespace.EventType.click, data);
      }
    }
  }
  mars2d__namespace.layer.ArcGisDynamicLayer = ArcGisDynamicLayer;

  // 注册下
  mars2d__namespace.LayerUtil.register("arcgis_dynamic", ArcGisDynamicLayer);

  // 以下是leaflet的内部方法，mars2d集成直接使用的，编写注释形成API文档

  /**
   * 在所有其他叠加层下方重绘此层。
   * @return {ArcGisDynamicLayer} 当前对象本身,可以链式调用
   *
   * @function bringToBack
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 在所有其他叠加层之上重绘此层。
   * @return {ArcGisDynamicLayer} 当前对象本身,可以链式调用
   *
   * @function bringToFront
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 绑定Popup弹窗配置
   * @param {Function} content Popup弹窗回调方法
   * @param {Map.PopupOptions|Object} [options] Popup弹窗参数
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   * @example
  dynamicMapLayer.bindPopup(function(err, featureCollection, response){
      var count = featureCollection.features.length;
      return (count) ? count + ' features' : false;
  });
   *
   * @function bindPopup
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 解除绑定Popup弹窗配置
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function unbindPopup
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 返回层构造函数中指定的可见层数组。
   * @return {String[]} 可见层数组
   *
   * @function getLayers
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 重绘图层以显示传递的图层 id 数组。
   * @param {String[]} layers 可见层数组
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function setLayers
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 返回用于渲染的当前层SQL筛选器。
   * @return {Object} SQL筛选器
   *
   * @function getLayerDefs
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 使用SQL筛选器新图层定义重绘图层, [layerDefs]{@link https://developers.arcgis.com/rest/services-reference/enterprise/export-map.htm}选项。
   * @param {Object} layerDefs SQL筛选器
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function setLayerDefs
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 返回一组 JSON 对象，表示从地图服务请求的修改后的图层符号系统。
   * @return {Object[]} SQL筛选器
   *
   * @function getDynamicLayers
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 在您想要修改服务本身中定义的图层符号系统的情况下，用于以数组形式插入原始 dynamicLayers JSON。
   * @param {Object[]} dynamicLayers SQL筛选器
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function setDynamicLayers
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 请求有关此要素图层的元数据。将使用error和调用回调metadata。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   * @example
  dynamicMapLayer.metadata(function(error, metadata){
    console.log(metadata);
  });
   * @function metadata
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 返回一个IdentifyFeatures新对象，可用于识别该图层上的要素。您的回调函数将传递一个带有结果或错误的GeoJSON。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {Object} [L.esri.services.IdentifyFeatures对象]{@link http://esri.github.io/esri-leaflet/api-reference/tasks/identify-features.html}
   * @example
  dynamicMapLayer.identify()
    .at(latlng)
    .run(function(error, featureCollection){
      console.log(featureCollection);
    });
   * @function identify
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 返回IdentifyFeatures可用于查找特征的新对象。您的回调函数将传递一个带有结果或错误的GeoJSON。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {Object} [L.esri.Find对象]{@link http://esri.github.io/esri-leaflet//api-reference/tasks/find.html}
   * @example
  dynamicMapLayer.find()
    .layers('18')
    .text('Colorado')
    .run(function(error, featureCollection){
      console.log(featureCollection);
    });
   * @function find
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 返回L.esri.Query可用于查询此服务的新对象。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {Object} [L.esri.Query对象]{@link http://esri.github.io/esri-leaflet/api-reference/tasks/query.html}
   * @example
  mapService.query()
    .layer(0)
    .within(latlngbounds)
    .run(function(error, featureCollection, response){
      console.log(featureCollection);
    });
   * @function query
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 用于向服务发出新请求并绘制响应。
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function redraw
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 将图层添加到地图
   * @param {Map} map  地图对象
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function addTo
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 将图层从地图上移除
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function remove
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * @typedef {Object} ArcGisFeatureLayer.EventType
   * 当前类支持的{@link EventType}事件类型（包括自定义字符串事件名）
   *
   * @property {String} loading 当新功能开始加载时触发。
   * @property {String} load 当地图当前边界中的所有要素都已加载时触发。
   *
   * @property {String} createfeature 首次加载要素图层中的要素时触发
   * @property {String} removefeature 当图层上的要素从地图中移除时触发
   * @property {String} addfeature 当先前删除的要素添加回地图时触发
   *
   * @property {String} click 当用户单击（or taps）地图时触发
   * @property {String} dblclick 当用户双击（or double-taps）地图时触发
   * @property {String} mousedown 当用户在图层上按下鼠标按钮时触发
   * @property {String} mouseover 当鼠标进入图层时触发
   * @property {String} mouseout 当鼠标离开图层时触发
   * @property {String} popupopen 当绑定到当前图层的Popup弹窗打开时触发
   * @property {String} popupclose 当绑定到当前图层的Popup弹窗关闭时触发
   *
   * @property {String} requeststart 当对服务的请求开始时触发。
   * @property {String} requestend 当对服务的请求结束时触发。
   * @property {String} requestsuccess 当对服务的请求成功时触发。
   * @property {String} requesterror 当对服务的请求响应错误时触发。
   * @property {String} authenticationrequired 当对服务的请求失败并需要身份验证时，这将被触发。
   *
   *
   * @example
   * //绑定监听事件
  tileLayer.on('load', function (event) {
    console.log('触发了事件',event)
  });
   * @see BaseClass#on
   * @see BaseClass#off
   */

  /**
   * ArcGIS Server WFS矢量服务图层，
   * 【需要引入mars2d-esri 插件库】
   *
   * @param {Object} options 参数对象，包括以下：
   * @param {String} options.url ArcGIS Server服务地址,如：https://sampleserver6.arcgisonline.com/arcgis/rest/services/Hurricanes/MapServer
   * @param {String} [options.where] 用于过滤服务器端的特性的可选表达式。字符串值应该用单引号表示，即:"FIELDNAME = '字段值'";可以找到有关有效SQL语法的更多信息。
   *
   * @param {Number} [options.minZoom] 图层将显示在地图上的最远缩放级别。
   * @param {Number} [options.maxZoom] 图层将显示在地图上的最近缩放级别。
   * @param {String} [options.token] 如果您在服务需要传递令牌，它将包含在对服务的所有请求中。
   * @param {String} [options.proxy]  代理服务URL
   * @param {Boolean} [options.useCors=true] 如果此服务在发出 GET 请求时应使用 CORS。
   * @param {Function} [options.onEachFeature] 提供了一个机会来内省图层中的各个 GeoJSON 功能。
   *
   * @param {Object|Function} [options.symbol] 矢量数据的style样式,为Function时是完全自定义的回调处理 symbol(attr, style, feature)
   * @param {GraphicType|String} [options.symbol.type] 标识数据类型，默认是根据数据生成 point、polyline、polygon
   * @param {Object} options.symbol.styleOptions Style样式，每种不同类型数据都有不同的样式，具体见各{@link GraphicType}矢量数据的style参数。
   * @param {String} [options.symbol.styleField] 按 styleField 属性设置不同样式。
   * @param {Object} [options.symbol.styleFieldOptions] 按styleField值与对应style样式的键值对象。
   * @param {Function} [options.symbol.callback] 自定义判断处理返回style ，示例：callback: function (attr, styleOpt){  return { color: "#ff0000" };  }
   *
   *
   * @param {String|Number} [options.id = createGuid()] 图层id标识
   * @param {String|Number} [options.pid = -1] 图层父级的id，一般图层管理中使用
   * @param {String} [options.name = ''] 图层名称
   * @param {String} [options.pane = 'overlayPane'] 指定图层添加到地图的哪个pane的DIV中，用于控制不同层级显示的，优先级高于zIndex。
   * @export
   * @class ArcGisFeatureLayer
   * @extends {L.esri.FeatureLayer}
   * @see [支持的事件类型]{@link ArcGisFeatureLayer.EventType}
   * @see [更多请参考L.esri.FeatureLayer类API]{@link http://esri.github.io/esri-leaflet/api-reference/layers/feature-layer.html}
   */
  class ArcGisFeatureLayer extends FeatureLayer {
    /**
     * 是否已添加到地图
     *
     * @type {Boolean}
     * @readonly
     *
     */
    get isAdded() {
      return this._map && this._map.hasLayer(this);
    }

    /**
     * 对象的pid标识
     *
     * @type {String|Number}
     */
    get pid() {
      return this.options.pid;
    }
    set pid(pid) {
      this.options.pid = pid;
    }

    /**
     * 对象的id标识
     *
     * @type {String|Number}
     */
    get id() {
      return this.options.id;
    }
    set id(id) {
      this.options.id = id;
    }

    /**
     * 名称 标识
     *
     * @type {String}
     */
    get name() {
      return this.options.name;
    }
    set name(name) {
      this.options.name = name;
    }

    /**
     * 显示隐藏状态
     *
     * @type {Boolean}
     */
    get show() {
      return this.options.show;
    }
    set show(show) {
      if (this.options.show === show) {
        return;
      }
      this.options.show = show;
      if (show) {
        if (this._map) {
          this.addTo(this._map);
        }
      } else {
        const map = this._map;
        this.remove();
        this._map = map;
      }
    }

    /**
     * 透明度
     * @type {Number}
     */
    get opacity() {
      return this.options.opacity;
    }
    set opacity(value) {
      this.options.opacity = value;
      this.setOpacity(value);
    }

    /**
     * 是否可以调整透明度
     * @type {boolean}
     * @readonly
     */
    get hasOpacity() {
      return true;
    }
    initialize(options) {
      var _this$options$id, _this$options$pid, _this$options$show;
      let popupConifg;
      if (options.popup) {
        popupConifg = options.popup;
        delete options.popup;
      }
      let tooltipConifg;
      if (options.tooltip) {
        tooltipConifg = options.tooltip;
        delete options.tooltip;
      }
      super.initialize(conventGeojsonOptions(options));
      L__default["default"].Util.stamp(this);
      this.options.id = (_this$options$id = this.options.id) !== null && _this$options$id !== void 0 ? _this$options$id : mars2d__namespace.Util.createGuid();
      this.options.pid = (_this$options$pid = this.options.pid) !== null && _this$options$pid !== void 0 ? _this$options$pid : -1;
      this.options.show = (_this$options$show = this.options.show) !== null && _this$options$show !== void 0 ? _this$options$show : true;
      if (popupConifg) {
        const popupOptions = this.options.popupOptions || {};
        this.bindPopup(evt => {
          var _evt$feature;
          // if (layer.hasOwnProperty("isPopup") && !layer.isPopup) {
          //   return;
          // }

          // if (_calbackClickFeature) {
          //   _calbackClickFeature("arcgis_feature", evt);
          // }

          const attr = (_evt$feature = evt.feature) === null || _evt$feature === void 0 ? void 0 : _evt$feature.properties;
          if (!attr) {
            return "";
          }
          let title = this.name;
          if (popupOptions.noTitle) {
            title = null;
          } else if (popupOptions.title) {
            title = popupOptions.title;
          } else if (popupOptions.titleField) {
            title = attr[popupOptions.titleField];
          }
          return mars2d__namespace.Util.getTemplateHtml({
            title: title,
            template: popupConifg,
            attr: attr
          });
        }, {
          maxWidth: 600
        });
      }
      if (tooltipConifg) {
        const popupOptions = this.options.tooltipOptions || {};
        this.bindTooltip(evt => {
          var _evt$feature2;
          const attr = (_evt$feature2 = evt.feature) === null || _evt$feature2 === void 0 ? void 0 : _evt$feature2.properties;
          if (!attr) {
            return "";
          }
          let title = this.name;
          if (popupOptions.noTitle) {
            title = null;
          } else if (popupOptions.title) {
            title = popupOptions.title;
          } else if (popupOptions.titleField) {
            title = attr[popupOptions.titleField];
          }
          return mars2d__namespace.Util.getTemplateHtml({
            title: title,
            template: tooltipConifg,
            attr: attr
          });
        }, {
          direction: "top"
        });
      }
    }
    createNewLayer(options) {
      const layer = super.createNewLayer(options); // GeoJSON.geometryToLayer(geojson, this.options)
      if (layer) {
        layer.parent = this;
      }
      return layer;
    }

    /**
     * 遍历所有矢量数据并将其作为参数传递给回调函数
     *
     * @param {Function} method 回调方法
     * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
     * @return {GraphicLayer} 当前对象本身,可以链式调用
     * @example
     *
    fl.on('load', function  () {
    fl.eachGraphic(function(layer) {
      console.log(layer.feature);
    });
    }
     */
    eachGraphic(method, context) {
      return this.eachFeature(method, context);
    }

    /**
     * 根据Feature 的 id取矢量数据对象
     *
     * @param {String|Number} id  Feature 的 id
     * @return {L.Layer} 矢量数据对象
     */
    getGraphicById(id) {
      return this.getFeature(id);
    }

    /**
     *
     * 设置覆盖的透明度
     * @param {Number} opacity  透明度，取值范围 0-1
     * @return {ArcGisFeatureLayer} 当前对象本身,可以链式调用
     */
    setOpacity(opacity) {
      if (opacity === 0) {
        opacity = 0.001;
      }
      this.options.opacity = opacity;
      const newStyle = {
        opacity: this.options.opacity,
        fillOpacity: this.options.opacity
      };
      this.eachGraphic(function (graphic) {
        if (graphic.setOpacity) {
          graphic.setOpacity(opacity);
        } else if (graphic.setStyle) {
          graphic.setStyle(newStyle);
        }
      }, this);
      return this;
    }

    /**
     * 获取图层矩形边界
     * @return {L.LatLngBounds} 矩形边界
     */
    getBounds() {
      let bounds;
      this.eachFeature(function (layer) {
        if (layer.getBounds) {
          var _bounds;
          const thisBounds = layer.getBounds();
          if ((_bounds = bounds) !== null && _bounds !== void 0 && _bounds._northEast) {
            bounds = bounds.extend(thisBounds);
          } else {
            bounds = thisBounds;
          }
        } else if (layer.getLatLng) {
          var _bounds2;
          const thisLatlng = layer.getLatLng();
          if ((_bounds2 = bounds) !== null && _bounds2 !== void 0 && _bounds2._northEast) {
            bounds = bounds.extend(thisLatlng);
          } else {
            bounds = L__default["default"].latLngBounds(thisLatlng, thisLatlng);
          }
        }
      }, this);
      return bounds;
    }

    /**
     * 定位地图至当前图层数据区域
     *
     * @param {Object} [options] 定位参数，包括:
     * @param {L.Point|Number[]} [options.paddingTopLeft] 设置在将视图设置为适合边界时不应考虑的地图容器左上角的填充量。如果您在地图上有一些控件重叠式（如侧边栏），而且您不希望它们遮挡您正在缩放的对象，则很有用。
     * @param {L.Point|Number[]} [options.paddingBottomRight] 同上，不考虑地图容器右下角时使用。
     * @param {L.Point|Number[]} [options.padding] 相当于将左上和右下填充设置为相同的值。
     * @param {Number} [options.maxZoom] 最大层级
     * @param {Boolean} [options.animate=true] 是否进行动画缩放。false时始终重置视图完全没有动画。
     * @param {Number} [options.duration=0.25] 动画平移的持续时间，以秒为单位。
     * @param {Number} [options.easeLinearity=0.25] 平移动画宽松的曲率因子 [Cubic Bezier curve曲线]{@link https://cubic-bezier.com/}的第三个参数。1.0表示线性动画，而这个数字越小，曲线越鞠躬。
     * @param {Boolean} [options.noMoveStart=false] 如果true，平移不会movestart在启动时触发事件（内部用于平移惯性）。
     * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
     */
    flyTo(options) {
      if (this._map) {
        const bounds = this.getBounds();
        if (bounds !== null && bounds !== void 0 && bounds._northEast) {
          this._map.flyToBounds(bounds, options);
        }
      }
      return this;
    }
  }
  mars2d__namespace.layer.ArcGisFeatureLayer = ArcGisFeatureLayer;

  // 注册下
  mars2d__namespace.LayerUtil.register("arcgis_feature", ArcGisFeatureLayer);
  function conventGeojsonOptions(options) {
    var _options$symbol;
    if (!options.symbol) {
      return options;
    }
    const newopts = {
      ...options
    };
    if ((_options$symbol = options.symbol) !== null && _options$symbol !== void 0 && _options$symbol.styleOptions) {
      // 点图层
      newopts.pointToLayer = function (geojson, latlng) {
        const attr = geojson.properties;
        const markopt = getMarkerSymbolStyle(options.symbol, attr);
        return L__default["default"].marker(latlng, markopt);
      };
      // 线面图层
      newopts.style = function (geojson) {
        const attr = geojson.properties;
        const styleOpt = mars2d__namespace.Util.getSymbolStyle(options.symbol, attr);
        return mars2d__namespace.PolygonStyleConver.toLeafletVal(styleOpt);
      };
      if (mars2d__namespace.Util.defined(options.symbol.type)) {
        if (mars2d__namespace.GraphicUtil.isPointType(options.symbol.type)) {
          delete newopts.style;
        } else {
          delete newopts.pointToLayer;
        }
      }
    }
    return newopts;
  }

  // /**
  //  * 根据symbol样式配置获取Marker点的构造参数
  //  *
  //  * @export
  //  * @param {Object} symbol 样式配置信息
  //  * @param {Object} symbol.styleOptions 样式信息
  //  * @param {String} [symbol.styleField] 分类字段名称
  //  * @param {Object} [symbol.styleFieldOptions] 分类字段值对应的样式
  //  * @param {Object} [attr] 属性信息
  //  * @param {Boolean} [isselected] 是否选中
  //  * @return {Object} Marker构造参数
  //  */
  function getMarkerSymbolStyle(symbol, attr, isselected) {
    if (!symbol) {
      return {};
    }
    let icoOpt = {
      ...symbol.styleOptions
    };
    if (symbol.styleField && attr) {
      // 存在多个symbol，按iconField进行分类
      const iconFieldVal = attr[symbol.styleField];
      const icoOptField = symbol.styleFieldOptions[iconFieldVal];
      if (icoOptField != null) {
        icoOpt = {
          ...icoOpt,
          ...icoOptField
        };
      }
    }
    if (isselected && icoOpt.iconUrlForSelect) {
      icoOpt.iconUrl = icoOpt.iconUrlForSelect;
    }
    if (icoOpt.hasOwnProperty("iconUrl")) {
      symbol.icon = L__default["default"].icon(icoOpt);
    } else if (icoOpt.hasOwnProperty("iconFont")) {
      let fontsize = 20;
      if (icoOpt.hasOwnProperty("iconSize")) {
        fontsize = icoOpt.iconSize[0];
      }
      const color = icoOpt.color || "#000000";
      icoOpt.className = "";
      icoOpt.html = '<i class="' + icoOpt.iconFont + '" style="color:' + color + ";font-size:" + fontsize + 'px;"></i> ';
      symbol.icon = L__default["default"].divIcon(icoOpt);
    } else {
      const color = icoOpt.color || "#0f89f5";
      let inhtml = '<div class="centerat_animation" style="color:' + color + ';"><p></p></div>';
      if (symbol.nameField) {
        const name = attr[symbol.nameField];
        inhtml += ' <div class="layer_divicon_name" style="top: 2px;left: 25px;" >' + name + "</div>";
      }
      symbol.icon = L__default["default"].divIcon({
        className: "",
        iconSize: [10, 10],
        iconAnchor: [5, 5],
        popupAnchor: [5, -5],
        tooltipAnchor: [5, -5],
        html: inhtml
      });
    }
    return symbol;
  }

  // 以下是leaflet的内部方法，mars2d集成直接使用的，编写注释形成API文档

  /**
   * 返回当前where设置
   * @return {String} where设置
   *
   * @function getWhere
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 设置新where选项并刷新图层以反映新where过滤器。
   * @param {String} where where设置
   * @param {Function} [callback] 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
   *
   * @function setWhere
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 请求有关此要素图层的元数据。将使用error和调用回调metadata。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
   * @example
  featureLayer.metadata(function(error, metadata){
    console.log(metadata);
  });
   * @function metadata
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 返回L.esri.Query可用于查询此服务的新对象。
   * @param {Function} callback 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {Object} [L.esri.Query对象]{@link http://esri.github.io/esri-leaflet/api-reference/tasks/query.html}
   * @example
  featureLayer.query()
    .within(latlngbounds)
    .where("Direction = 'WEST'")
    .run(function(error, featureCollection){
      console.log(featureCollection);
    });
   * @function query
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 向要素图层添加新要素。如果创建成功，这也会将该功能添加到地图中。
   * <ul>
   * <li>需要以有权在 ArcGIS Online 中编辑服务的用户或创建服务的用户身份进行身份验证。</li>
   * <li>需要Create在服务上启用该功能。您可以通过在功能下检查服务的元数据来检查创建是否存在。</li>
   * </ul>
   * @param {Object} feature GeoJSON Feature对象
   * @param {Function} [callback] 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
   *
   * @function addFeature
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 更新要素图层上提供的要素。这也会更新地图上的要素。
   * <ul>
   * <li>需要以有权在 ArcGIS Online 中编辑服务的用户或创建服务的用户身份进行身份验证。</li>
   * <li>需要Create在服务上启用该功能。您可以通过在功能下检查服务的元数据来检查创建是否存在。</li>
   * </ul>
   * @param {Object} feature GeoJSON Feature对象
   * @param {Function} [callback] 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
   *
   * @function updateFeature
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 从要素图层中删除具有提供的 id 的要素。如果该要素存在，这也会从地图中删除该要素。
   * <ul>
   * <li>需要以有权在 ArcGIS Online 中编辑服务的用户或创建服务的用户身份进行身份验证。</li>
   * <li>需要Create在服务上启用该功能。您可以通过在功能下检查服务的元数据来检查创建是否存在。</li>
   * </ul>
   * @param {String|Number} id 要素的 id
   * @param {Function} [callback] 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
   *
   * @function deleteFeature
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 从要素层中删除具有提供的 id 的要素数组。这也会从地图中删除特征（如果存在）。
   * <ul>
   * <li>需要以有权在 ArcGIS Online 中编辑服务的用户或创建服务的用户身份进行身份验证。</li>
   * <li>需要Create在服务上启用该功能。您可以通过在功能下检查服务的元数据来检查创建是否存在。</li>
   * </ul>
   * @param {String[]|Number[]} ids 要素的id数组
   * @param {Function} [callback] 回调方法
   * @param {Object} [context]  侦听器的上下文(this关键字将指向的对象)。
   * @return {ArcGisFeatureLayer} 当前对象本身，可以链式调用
   *
   * @function deleteFeatures
   * @memberof ArcGisFeatureLayer
   * @instance
   */

  /**
   * 从要素层使用提供的 id 重绘要素。
   * @param {String|Number} id 要素的 id
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function redraw
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 从地图上存在的要素图层重新绘制所有要素。
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function refresh
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 将图层添加到地图
   * @param {Map} map  地图对象
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function addTo
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  /**
   * 将图层从地图上移除
   * @return {ArcGisDynamicLayer} 当前对象本身，可以链式调用
   *
   * @function remove
   * @memberof ArcGisDynamicLayer
   * @instance
   */

  L__default["default"].esri = LEsri;
  // eslint-disable-next-line no-import-assign
  mars2d__namespace.esri = LEsri;

  exports.ArcGisDynamicLayer = ArcGisDynamicLayer;
  exports.ArcGisFeatureLayer = ArcGisFeatureLayer;
  exports.ArcGisImageLayer = ArcGisImageLayer;
  exports.ArcGisTileLayer = ArcGisTileLayer;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
